// AdvCompOptions_Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "q2_otter.h"
#include "AdvCompOptions_Dlg.h"


// CAdvCompOptions_Dlg dialog

IMPLEMENT_DYNAMIC(CAdvCompOptions_Dlg, CDialog)

CAdvCompOptions_Dlg::CAdvCompOptions_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAdvCompOptions_Dlg::IDD, pParent)
	, m_bFastCompile(FALSE)
	, m_nCompileThreads(4)
	, m_bVerbose(FALSE)
	, m_bVerboseLogged(FALSE)
	, m_nSurfaceChop(256)
	, m_bOldBounds(FALSE)
	, m_bVerboseEnts(FALSE)
	, m_bVerboseBrushes(FALSE)
	, m_bNoWeld(FALSE)
	, m_bNoCSG(FALSE)
	, m_bNoShare(FALSE)
	, m_bNotJunc(FALSE)
	, m_bNoWater(FALSE)
	, m_bNoOpt(FALSE)
	, m_bNoPrune(FALSE)
	, m_bNoMerge(FALSE)
	, m_bNoSubdiv(FALSE)
	, m_bNoDetail(FALSE)
	, m_bFullDetail(FALSE)
	, m_bNoHints(FALSE)
	, m_bQBSP_GLView(FALSE)
	, m_bVisNoSort(FALSE)
	, m_nRadBounces(8)
	, m_nRadChop(128)
	, m_fRadScale(1)
	, m_fRadSurfScale(1)
	, m_fRadEntScale(1)
	, m_fRadAmbient(0)
	, m_fRadMaxlight(0)
	, m_bRadExtra(FALSE)
	, m_bRadNoPVS(FALSE)
	, m_bRadDumpPatches(FALSE)
	, m_bRadGLView(FALSE)
	, m_nRadChopSky(0)
	, m_nRadChopWarp(0)
	, m_nRadChopLight(0)
	, m_nRadChopCurve(0)
	, m_nRadAmbientAbs(0)
	, m_nRadMaxlightAbs(0)
	, m_fRadRadmin(0)
	, m_bRadNoColor(FALSE)
	, m_bRadNoColorU(FALSE)
	, m_bRadNoMinlimit(FALSE)
	, m_bRadNoBModLight(FALSE)
	, m_bRadNoStopBleed(FALSE)
	, m_bRadNoCurve(FALSE)
	, m_bRadNoSplotchFix(FALSE)
	, m_bRadOnlyBounce(FALSE)
{

}

CAdvCompOptions_Dlg::~CAdvCompOptions_Dlg()
{
}

void CAdvCompOptions_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_COM_THREADS, m_ctlEditCompileThreads);
	DDX_Control(pDX, IDC_SPIN_COM_THREADS, m_ctlSpinCompileThreads);
	DDX_Text(pDX, IDC_EDIT_COM_THREADS, m_nCompileThreads);
	DDV_MinMaxInt(pDX, m_nCompileThreads, 1, 64);
	DDX_Control(pDX, IDC_CHECK_COM_VERBOSE, m_ctlCheckVerbose);
	DDX_Check(pDX, IDC_CHECK_COM_VERBOSE, m_bVerbose);
	DDX_Control(pDX, IDC_CHECK_COM_VERBOSE_LOGGED, m_ctlCheckVerboseLogged);
	DDX_Check(pDX, IDC_CHECK_COM_VERBOSE_LOGGED, m_bVerboseLogged);
	DDX_Control(pDX, IDC_EDIT_QBSP_SURFACECHOP, m_ctlEditSurfaceChop);
	DDX_Control(pDX, IDC_SPIN_QBSP_SURFACECHOP, m_ctlSpinSurfaceChop);
	DDX_Text(pDX, IDC_EDIT_QBSP_SURFACECHOP, m_nSurfaceChop);
	DDV_MinMaxInt(pDX, m_nSurfaceChop, 240, 1024);
	DDX_Control(pDX, IDC_CHECK_QBSP_OLDBOUNDS, m_ctlCheckOldBounds);
	DDX_Check(pDX, IDC_CHECK_QBSP_OLDBOUNDS, m_bOldBounds);
	DDX_Control(pDX, IDC_CHECK_QBSP_VERBOSEENTS, m_ctlCheckVerboseEnts);
	DDX_Check(pDX, IDC_CHECK_QBSP_VERBOSEENTS, m_bVerboseEnts);
	DDX_Control(pDX, IDC_CHECK_QBSP_VERBOSEBRUSHES, m_ctlCheckVerboseBrushes);
	DDX_Check(pDX, IDC_CHECK_QBSP_VERBOSEBRUSHES, m_bVerboseBrushes);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOWELD, m_ctlCheckNoWeld);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOWELD, m_bNoWeld);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOCSG, m_ctlCheckNoCSG);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOCSG, m_bNoCSG);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOSHARE, m_ctlCheckNoShare);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOSHARE, m_bNoShare);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOTJUNC, m_ctlCheckNotJunc);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOTJUNC, m_bNotJunc);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOWATER, m_ctlCheckNoWater);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOWATER, m_bNoWater);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOOPT, m_ctlCheckNoOpt);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOOPT, m_bNoOpt);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOPRUNE, m_ctlCheckNoPrune);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOPRUNE, m_bNoPrune);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOMERGE, m_ctlCheckNoMerge);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOMERGE, m_bNoMerge);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOSUBDIV, m_ctlCheckNoSubdiv);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOSUBDIV, m_bNoSubdiv);
	DDX_Control(pDX, IDC_CHECK_QBSP_NODETAIL, m_ctlCheckNoDetail);
	DDX_Check(pDX, IDC_CHECK_QBSP_NODETAIL, m_bNoDetail);
	DDX_Control(pDX, IDC_CHECK_QBSP_FULLDETAIL, m_ctlCheckFullDetail);
	DDX_Check(pDX, IDC_CHECK_QBSP_FULLDETAIL, m_bFullDetail);
	DDX_Control(pDX, IDC_CHECK_QBSP_NOHINTS, m_ctlCheckNoHints);
	DDX_Check(pDX, IDC_CHECK_QBSP_NOHINTS, m_bNoHints);
	DDX_Control(pDX, IDC_CHECK_QBSP_GLVIEW, m_ctlCheckQBSP_GLView);
	DDX_Check(pDX, IDC_CHECK_QBSP_GLVIEW, m_bQBSP_GLView);
	DDX_Control(pDX, IDC_CHECK_VIS_NOSORT, m_ctlCheckVisNoSort);
	DDX_Check(pDX, IDC_CHECK_VIS_NOSORT, m_bVisNoSort);
	DDX_Control(pDX, IDC_EDIT_RAD_BOUNCES, m_ctlEditRadBounces);
	DDX_Control(pDX, IDC_SPIN_RAD_BOUNCES, m_ctlSpinRadBounces);
	DDX_Text(pDX, IDC_EDIT_RAD_BOUNCES, m_nRadBounces);
	DDV_MinMaxInt(pDX, m_nRadBounces, 0, 16);
	DDX_Control(pDX, IDC_EDIT_RAD_CHOP, m_ctlEditRadChop);
	DDX_Control(pDX, IDC_SPIN_RAD_CHOP, m_ctlSpinRadChop);
	DDX_Text(pDX, IDC_EDIT_RAD_CHOP, m_nRadChop);
	DDV_MinMaxInt(pDX, m_nRadChop, 32, 1024);
	DDX_Control(pDX, IDC_EDIT_RAD_SCALE, m_ctlEditRadScale);
	DDX_Control(pDX, IDC_SPIN_RAD_SCALE, m_ctlSpinRadScale);
	DDX_Text(pDX, IDC_EDIT_RAD_SCALE, m_fRadScale);
	DDX_Control(pDX, IDC_EDIT_RAD_SURFSCALE, m_ctlEditRadSurfScale);
	DDX_Control(pDX, IDC_SPIN_RAD_SURFSCALE, m_ctlSpinRadSurfScale);
	DDX_Text(pDX, IDC_EDIT_RAD_SURFSCALE, m_fRadSurfScale);
	DDX_Control(pDX, IDC_EDIT_RAD_ENTSCALE, m_ctlEditRadEntScale);
	DDX_Control(pDX, IDC_SPIN_RAD_ENTSCALE, m_ctlSpinRadEntScale);
	DDX_Text(pDX, IDC_EDIT_RAD_ENTSCALE, m_fRadEntScale);
	DDX_Control(pDX, IDC_EDIT_RAD_AMBIENT, m_ctlEditRadAmbient);
	DDX_Control(pDX, IDC_SPIN_RAD_AMBIENT, m_ctlSpinRadAmbient);
	DDX_Text(pDX, IDC_EDIT_RAD_AMBIENT, m_fRadAmbient);
	DDX_Control(pDX, IDC_EDIT_RAD_MAXLIGHT, m_ctlEditRadMaxlight);
	DDX_Control(pDX, IDC_SPIN_RAD_MAXLIGHT, m_ctlSpinRadMaxlight);
	DDX_Text(pDX, IDC_EDIT_RAD_MAXLIGHT, m_fRadMaxlight);
	DDX_Control(pDX, IDC_CHECK_RAD_EXTRA, m_ctlCheckRadExtra);
	DDX_Check(pDX, IDC_CHECK_RAD_EXTRA, m_bRadExtra);
	DDX_Control(pDX, IDC_CHECK_RAD_NOPVS, m_ctlCheckRadNoPVS);
	DDX_Check(pDX, IDC_CHECK_RAD_NOPVS, m_bRadNoPVS);
	DDX_Control(pDX, IDC_CHECK_RAD_DUMPPATCHES, m_ctlCheckRadDumpPatches);
	DDX_Check(pDX, IDC_CHECK_RAD_DUMPPATCHES, m_bRadDumpPatches);
	DDX_Control(pDX, IDC_CHECK_RAD_GLVIEW, m_ctlCheckRadGLView);
	DDX_Check(pDX, IDC_CHECK_RAD_GLVIEW, m_bRadGLView);
	DDX_Control(pDX, IDC_EDIT_RAD_CHOPSKY, m_ctlEditRadChopSky);
	DDX_Control(pDX, IDC_SPIN_RAD_CHOPSKY, m_ctlSpinRadChopSky);
	DDX_Text(pDX, IDC_EDIT_RAD_CHOPSKY, m_nRadChopSky);
	DDV_MinMaxInt(pDX, m_nRadChopSky, 0, 1024);
	DDX_Control(pDX, IDC_EDIT_RAD_CHOPWARP, m_ctlEditRadChopWarp);
	DDX_Control(pDX, IDC_SPIN_RAD_CHOPWARP, m_ctlSpinRadChopWarp);
	DDX_Text(pDX, IDC_EDIT_RAD_CHOPWARP, m_nRadChopWarp);
	DDV_MinMaxInt(pDX, m_nRadChopWarp, 0, 1024);
	DDX_Control(pDX, IDC_EDIT_RAD_CHOPLIGHT, m_ctlEditRadChopLight);
	DDX_Control(pDX, IDC_SPIN_RAD_CHOPLIGHT, m_ctlSpinRadChopLight);
	DDX_Text(pDX, IDC_EDIT_RAD_CHOPLIGHT, m_nRadChopLight);
	DDV_MinMaxInt(pDX, m_nRadChopLight, 0, 1024);
	DDX_Control(pDX, IDC_EDIT_RAD_CHOPCURVE, m_ctlEditRadChopCurve);
	DDX_Control(pDX, IDC_SPIN_RAD_CHOPCURVE, m_ctlSpinRadChopCurve);
	DDX_Text(pDX, IDC_EDIT_RAD_CHOPCURVE, m_nRadChopCurve);
	DDV_MinMaxInt(pDX, m_nRadChopCurve, 0, 1024);
	DDX_Control(pDX, IDC_EDIT_RAD_AMBIENTA, m_ctlEditRadAmbientAbs);
	DDX_Control(pDX, IDC_SPIN_RAD_AMBIENTA, m_ctlSpinRadAmbientAbs);
	DDX_Text(pDX, IDC_EDIT_RAD_AMBIENTA, m_nRadAmbientAbs);
	DDV_MinMaxInt(pDX, m_nRadAmbientAbs, 0, 128);
	DDX_Control(pDX, IDC_EDIT_RAD_MAXLIGHTA, m_ctlEditRadMaxlightAbs);
	DDX_Control(pDX, IDC_SPIN_RAD_MAXLIGHTA, m_ctlSpinRadMaxlightAbs);
	DDX_Text(pDX, IDC_EDIT_RAD_MAXLIGHTA, m_nRadMaxlightAbs);
	DDV_MinMaxInt(pDX, m_nRadMaxlightAbs, 0, 255);
	DDX_Control(pDX, IDC_EDIT_RAD_RADMIN, m_ctlEditRadRadmin);
	DDX_Control(pDX, IDC_SPIN_RAD_RADMIN, m_ctlSpinRadRadmin);
	DDX_Text(pDX, IDC_EDIT_RAD_RADMIN, m_fRadRadmin);
	DDX_Control(pDX, IDC_CHECK_RAD_NOCOLOR, m_ctlCheckRadNoColor);
	DDX_Check(pDX, IDC_CHECK_RAD_NOCOLOR, m_bRadNoColor);
	DDX_Control(pDX, IDC_CHECK_RAD_NOCOLORU, m_ctlCheckRadNoColorU);
	DDX_Check(pDX, IDC_CHECK_RAD_NOCOLORU, m_bRadNoColorU);
	DDX_Control(pDX, IDC_CHECK_RAD_NOMINLIMIT, m_ctlCheckRadNoMinlimit);
	DDX_Check(pDX, IDC_CHECK_RAD_NOMINLIMIT, m_bRadNoMinlimit);
	DDX_Control(pDX, IDC_CHECK_RAD_NOBMODLIGHT, m_ctlCheckRadNoBModLight);
	DDX_Check(pDX, IDC_CHECK_RAD_NOBMODLIGHT, m_bRadNoBModLight);
	DDX_Control(pDX, IDC_CHECK_RAD_NOSTOPBLEED, m_ctlCheckRadNoStopBleed);
	DDX_Check(pDX, IDC_CHECK_RAD_NOSTOPBLEED, m_bRadNoStopBleed);
	DDX_Control(pDX, IDC_CHECK_RAD_NOCURVE, m_ctlEditRadNoCurve);
	DDX_Check(pDX, IDC_CHECK_RAD_NOCURVE, m_bRadNoCurve);
	DDX_Control(pDX, IDC_CHECK_RAD_NOSPLOTCHFIX, m_ctlCheckRadNoSplotchFix);
	DDX_Check(pDX, IDC_CHECK_RAD_NOSPLOTCHFIX, m_bRadNoSplotchFix);
	DDX_Control(pDX, IDC_CHECK_RAD_ONLYBOUNCE, m_ctlCheckRadOnlyBounce);
	DDX_Check(pDX, IDC_CHECK_RAD_ONLYBOUNCE, m_bRadOnlyBounce);
}


BEGIN_MESSAGE_MAP(CAdvCompOptions_Dlg, CDialog)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_QBSP_SURFACECHOP, &CAdvCompOptions_Dlg::OnDeltaposSpinSurfacechop)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_CHOP, &CAdvCompOptions_Dlg::OnDeltaposSpinRadChop)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_SCALE, &CAdvCompOptions_Dlg::OnDeltaposSpinRadScale)
	ON_EN_CHANGE(IDC_EDIT_RAD_SCALE, &CAdvCompOptions_Dlg::OnEnChangeEditRadScale)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_SURFSCALE, &CAdvCompOptions_Dlg::OnDeltaposSpinRadSurfscale)
	ON_EN_CHANGE(IDC_EDIT_RAD_SURFSCALE, &CAdvCompOptions_Dlg::OnEnChangeEditRadSurfscale)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_ENTSCALE, &CAdvCompOptions_Dlg::OnDeltaposSpinRadEntscale)
	ON_EN_CHANGE(IDC_EDIT_RAD_ENTSCALE, &CAdvCompOptions_Dlg::OnEnChangeEditRadEntscale)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_AMBIENT, &CAdvCompOptions_Dlg::OnDeltaposSpinRadAmbient)
	ON_EN_CHANGE(IDC_EDIT_RAD_AMBIENT, &CAdvCompOptions_Dlg::OnEnChangeEditRadAmbient)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_MAXLIGHT, &CAdvCompOptions_Dlg::OnDeltaposSpinRadMaxlight)
	ON_EN_CHANGE(IDC_EDIT_RAD_MAXLIGHT, &CAdvCompOptions_Dlg::OnEnChangeEditRadMaxlight)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_CHOPSKY, &CAdvCompOptions_Dlg::OnDeltaposSpinRadChopsky)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_CHOPWARP, &CAdvCompOptions_Dlg::OnDeltaposSpinRadChopwarp)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_CHOPLIGHT, &CAdvCompOptions_Dlg::OnDeltaposSpinRadChoplight)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_CHOPCURVE, &CAdvCompOptions_Dlg::OnDeltaposSpinRadChopcurve)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RAD_RADMIN, &CAdvCompOptions_Dlg::OnDeltaposSpinRadRadmin)
	ON_EN_CHANGE(IDC_EDIT_RAD_RADMIN, &CAdvCompOptions_Dlg::OnEnChangeEditRadRadmin)
	ON_BN_CLICKED(IDC_BUTTON_RESET_DEFAULTS, &CAdvCompOptions_Dlg::OnBnClickedButtonResetDefaults)
END_MESSAGE_MAP()


// CAdvCompOptions_Dlg message handlers

BOOL CAdvCompOptions_Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	m_ctlSpinCompileThreads.SetRange(1, 64);

	m_ctlSpinSurfaceChop.SetRange(0, 49);

	m_ctlSpinRadBounces.SetRange(0, 16);
	m_ctlSpinRadChop.SetRange(1, 32);
	m_ctlSpinRadScale.SetRange(1, 200);
	m_ctlSpinRadScale.SetPos(20);
	m_ctlEditRadScale.SetLimitText(4);
	m_ctlEditRadScale.m_bAllowNegativeValues = false;
	m_ctlSpinRadSurfScale.SetRange(1, 200);
	m_ctlSpinRadSurfScale.SetPos(20);
	m_ctlEditRadSurfScale.SetLimitText(4);
	m_ctlEditRadSurfScale.m_bAllowNegativeValues = false;
	m_ctlSpinRadEntScale.SetRange(1, 200);
	m_ctlSpinRadEntScale.SetPos(20);
	m_ctlEditRadEntScale.SetLimitText(4);
	m_ctlEditRadEntScale.m_bAllowNegativeValues = false;
	m_ctlSpinRadAmbient.SetRange(0, 100);
	m_ctlSpinRadAmbient.SetPos(0);
	m_ctlEditRadAmbient.SetLimitText(4);
	m_ctlEditRadAmbient.m_bAllowNegativeValues = false;
	m_ctlSpinRadMaxlight.SetRange(0, 200);
	m_ctlSpinRadMaxlight.SetPos(0);
	m_ctlEditRadMaxlight.SetLimitText(4);
	m_ctlEditRadMaxlight.m_bAllowNegativeValues = false;

	m_ctlSpinRadChopSky.SetRange(0, 32);
	m_ctlSpinRadChopSky.SetPos(0);
	m_ctlSpinRadChopWarp.SetRange(0, 32);
	m_ctlSpinRadChopWarp.SetPos(0);
	m_ctlSpinRadChopLight.SetRange(0, 32);
	m_ctlSpinRadChopLight.SetPos(0);
	m_ctlSpinRadChopCurve.SetRange(0, 32);
	m_ctlSpinRadChopCurve.SetPos(0);
	m_ctlSpinRadAmbientAbs.SetRange(0, 128);
	m_ctlSpinRadMaxlightAbs.SetRange(0, 255);
	m_ctlSpinRadRadmin.SetRange(0, 1000);
	m_ctlSpinRadRadmin.SetPos(0);
	m_ctlEditRadRadmin.SetLimitText(5);
	m_ctlEditRadRadmin.m_bAllowNegativeValues = false;

	// Create ToolTip
	if ( !m_ToolTip.Create(this) )
	{
		MessageBox("Couldn't create tooltip.", "Error", MB_OK | MB_ICONERROR);
	}
	else
	{
		// Add tool tips to controls
		m_ToolTip.AddTool (&m_ctlEditCompileThreads, _T("The number of computation threads for Qvis and Qrad/ArghRad to use, this should be the number of CPU cores in your system."));
		m_ToolTip.AddTool (&m_ctlCheckVerbose, _T("Enables global verbose output."));
		m_ToolTip.AddTool (&m_ctlCheckVerboseLogged, _T("Enables global verbose logged output."));

		m_ToolTip.AddTool (&m_ctlEditSurfaceChop, _T("The size of QBSP surface subdivisions, from 240 - 1024.  Larger values result in lower r_speeds."));

		m_ToolTip.AddTool (&m_ctlCheckOldBounds, _T("Enables old +/- 4096 map bounds for maps meant for vanilla Quake2."));
		m_ToolTip.AddTool (&m_ctlCheckVerboseEnts, _T("Enables verbose output of entity info by QBSP."));
		m_ToolTip.AddTool (&m_ctlCheckVerboseBrushes, _T("Enables verbose output of brush info by QBSP.  Handy for troubleshooting \"FloatPlane: bad normal\" errors."));
		m_ToolTip.AddTool (&m_ctlCheckNoWeld, _T("Disables welding of vertices for adjacent surface polygons."));
		m_ToolTip.AddTool (&m_ctlCheckNoCSG, _T("Disables chopping of intersecting brushes."));
		m_ToolTip.AddTool (&m_ctlCheckNoShare, _T("Disables edges sharing faces."));
		m_ToolTip.AddTool (&m_ctlCheckNotJunc, _T("Disables fixing of edges shared between faces."));
		m_ToolTip.AddTool (&m_ctlCheckNoWater, _T("Disables water, slime, and lava brushes/volumes."));
		m_ToolTip.AddTool (&m_ctlCheckNoOpt, _T("Disables optimization of BSP tree structure."));
		m_ToolTip.AddTool (&m_ctlCheckNoPrune, _T("Disables pruning of BSP nodes."));
		m_ToolTip.AddTool (&m_ctlCheckNoMerge, _T("Disables merging of node faces."));
		m_ToolTip.AddTool (&m_ctlCheckNoSubdiv, _T("Disables subdivision of node faces."));
		m_ToolTip.AddTool (&m_ctlCheckNoDetail, _T("Disables detail brushes."));
		m_ToolTip.AddTool (&m_ctlCheckFullDetail, _T("Forces detail brushes to be processed as structural brushes."));
		m_ToolTip.AddTool (&m_ctlCheckNoHints, _T("Disables hint brushes."));
		m_ToolTip.AddTool (&m_ctlCheckQBSP_GLView, _T("Enables output .gl text file of flat-shaded vertices."));

		m_ToolTip.AddTool (&m_ctlCheckVisNoSort, _T("Disables sorting of VIS portals."));

		m_ToolTip.AddTool (&m_ctlEditRadBounces, _T("The number of radiosity bounces for Qrad/ArghRad to use, higher means light spreads further."));
		m_ToolTip.AddTool (&m_ctlEditRadChop, _T("The surface patch size for Qrad/ArghRad to use, lower means higher quality."));
		m_ToolTip.AddTool (&m_ctlEditRadScale, _T("The lighting scale for Qrad/ArghRad to use, higher means brigher."));
		m_ToolTip.AddTool (&m_ctlEditRadSurfScale, _T("The lighting scale for surface lights."));
		m_ToolTip.AddTool (&m_ctlEditRadEntScale, _T("The lighting scale for entity lights."));
		m_ToolTip.AddTool (&m_ctlEditRadAmbient, _T("The global minimum brightness, normalized scale (0-1)."));
		m_ToolTip.AddTool (&m_ctlEditRadMaxlight, _T("The global maximum brightness, normalized scale (0-2)."));
		m_ToolTip.AddTool (&m_ctlCheckRadExtra, _T("Enables extra quality light sampling."));
		m_ToolTip.AddTool (&m_ctlCheckRadNoPVS, _T("Disables PVS checking."));
		m_ToolTip.AddTool (&m_ctlCheckRadDumpPatches, _T("Enables patch info dump (bounce*.txt)."));
		m_ToolTip.AddTool (&m_ctlCheckRadGLView, _T("Enables output .glr text file of vertices and light values."));

		m_ToolTip.AddTool (&m_ctlEditRadChopSky, _T("Sets sky patch size (default 256)."));
		m_ToolTip.AddTool (&m_ctlEditRadChopWarp, _T("Sets warp patch size (default 256)."));
		m_ToolTip.AddTool (&m_ctlEditRadChopLight, _T("Sets normal light patch size (default 256)."));
		m_ToolTip.AddTool (&m_ctlEditRadChopCurve, _T("Sets curve patch size (default 32)."));
		m_ToolTip.AddTool (&m_ctlEditRadAmbientAbs, _T("The global minumum brightness, absolute scale (0-128)."));
		m_ToolTip.AddTool (&m_ctlEditRadMaxlightAbs, _T("The global maximum brightness, absolute scale (0-255)."));
		m_ToolTip.AddTool (&m_ctlEditRadRadmin, _T("The minimum cutoff value for radiosity transfers."));
		m_ToolTip.AddTool (&m_ctlCheckRadNoColor, _T("Converts lighting to grayscale, RGB weighted."));
		m_ToolTip.AddTool (&m_ctlCheckRadNoColorU, _T("Converts lighting to grayscale, unweighted."));
		m_ToolTip.AddTool (&m_ctlCheckRadNoMinlimit, _T("Allows antilights to go darker than minlight."));
		m_ToolTip.AddTool (&m_ctlCheckRadNoBModLight, _T("Disables brush model lighting."));
		m_ToolTip.AddTool (&m_ctlCheckRadNoStopBleed, _T("Disables bleeding light correction."));
		m_ToolTip.AddTool (&m_ctlEditRadNoCurve, _T("Disables phong shading."));
		m_ToolTip.AddTool (&m_ctlCheckRadNoSplotchFix, _T("Disables anti-splotch fix for plain face lights."));
		m_ToolTip.AddTool (&m_ctlCheckRadOnlyBounce, _T("Specifies saving of only bounced light."));
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// Knightmare added
BOOL CAdvCompOptions_Dlg::PreTranslateMessage(MSG *pMsg)
{
	m_ToolTip.RelayEvent(pMsg);
	return CDialog::PreTranslateMessage(pMsg);
}

void CAdvCompOptions_Dlg::OnDeltaposSpinSurfacechop(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_nSurfaceChop -= 16;
	}
	else	// increment
	{
		m_nSurfaceChop += 16;
	}
	m_nSurfaceChop = max(m_nSurfaceChop, 240);
	m_nSurfaceChop = min(m_nSurfaceChop, 1024);
	UpdateData(false);

	*pResult = 0;
}
void CAdvCompOptions_Dlg::OnDeltaposSpinRadChop(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_nRadChop -= 32;
	}
	else	// increment
	{
		m_nRadChop += 32;
	}
	m_nRadChop = max(m_nRadChop, 32);
	m_nRadChop = min(m_nRadChop, 1024);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadScale(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_fRadScale -= 0.05f;
	}
	else	// increment
	{
		m_fRadScale += 0.05f;
	}
	m_fRadScale = max(m_fRadScale, 0.05f);
	m_fRadScale = min(m_fRadScale, 10.0f);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnEnChangeEditRadScale()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strRadScale;
	GetDlgItemText(IDC_EDIT_RAD_SCALE, strRadScale);

	m_fRadScale = (float)atof((LPCSTR)strRadScale);

	UpdateData(true);	
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadSurfscale(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_fRadSurfScale -= 0.05f;
	}
	else	// increment
	{
		m_fRadSurfScale += 0.05f;
	}
	m_fRadSurfScale = max(m_fRadSurfScale, 0.05f);
	m_fRadSurfScale = min(m_fRadSurfScale, 10.0f);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnEnChangeEditRadSurfscale()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strRadSurfScale;
	GetDlgItemText(IDC_EDIT_RAD_SURFSCALE, strRadSurfScale);

	m_fRadSurfScale = (float)atof((LPCSTR)strRadSurfScale);

	UpdateData(true);	
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadEntscale(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_fRadEntScale -= 0.05f;
	}
	else	// increment
	{
		m_fRadEntScale += 0.05f;
	}
	m_fRadEntScale = max(m_fRadEntScale, 0.05f);
	m_fRadEntScale = min(m_fRadEntScale, 10.0f);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnEnChangeEditRadEntscale()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strRadEntScale;
	GetDlgItemText(IDC_EDIT_RAD_ENTSCALE, strRadEntScale);

	m_fRadEntScale = (float)atof((LPCSTR)strRadEntScale);

	UpdateData(true);	
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadAmbient(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_fRadAmbient -= 0.01f;
	}
	else	// increment
	{
		m_fRadAmbient += 0.01f;
	}
	m_fRadAmbient = max(m_fRadAmbient, 0.0f);
	m_fRadAmbient = min(m_fRadAmbient, 1.0f);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnEnChangeEditRadAmbient()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strRadAmbient;
	GetDlgItemText(IDC_EDIT_RAD_AMBIENT, strRadAmbient);

	m_fRadAmbient = (float)atof((LPCSTR)strRadAmbient);

	UpdateData(true);	
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadMaxlight(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_fRadMaxlight -= 0.01f;
	}
	else	// increment
	{
		m_fRadMaxlight += 0.01f;
	}
	m_fRadMaxlight = max(m_fRadMaxlight, 0.0f);
	m_fRadMaxlight = min(m_fRadMaxlight, 2.0f);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnEnChangeEditRadMaxlight()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strRadMaxlight;
	GetDlgItemText(IDC_EDIT_RAD_MAXLIGHT, strRadMaxlight);

	m_fRadMaxlight = (float)atof((LPCSTR)strRadMaxlight);

	UpdateData(true);	
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadChopsky(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_nRadChopSky -= 32;
	}
	else	// increment
	{
		m_nRadChopSky += 32;
	}
	m_nRadChopSky = max(m_nRadChopSky, 0);
	m_nRadChopSky = min(m_nRadChopSky, 1024);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadChopwarp(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_nRadChopWarp -= 32;
	}
	else	// increment
	{
		m_nRadChopWarp += 32;
	}
	m_nRadChopWarp = max(m_nRadChopWarp, 0);
	m_nRadChopWarp = min(m_nRadChopWarp, 1024);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadChoplight(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_nRadChopLight -= 32;
	}
	else	// increment
	{
		m_nRadChopLight += 32;
	}
	m_nRadChopLight = max(m_nRadChopLight, 0);
	m_nRadChopLight = min(m_nRadChopLight, 1024);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadChopcurve(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_nRadChopCurve -= 32;
	}
	else	// increment
	{
		m_nRadChopCurve += 32;
	}
	m_nRadChopCurve = max(m_nRadChopCurve, 0);
	m_nRadChopCurve = min(m_nRadChopCurve, 1024);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnDeltaposSpinRadRadmin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_fRadRadmin -= 0.001f;
	}
	else	// increment
	{
		m_fRadRadmin += 0.001f;
	}
	m_fRadRadmin = max(m_fRadRadmin, 0.0f);
	m_fRadRadmin = min(m_fRadRadmin, 1.0f);
	UpdateData(false);

	*pResult = 0;
}

void CAdvCompOptions_Dlg::OnEnChangeEditRadRadmin()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strRadRadmin;
	GetDlgItemText(IDC_EDIT_RAD_RADMIN, strRadRadmin);

	m_fRadRadmin = (float)atof((LPCSTR)strRadRadmin);

	UpdateData(true);	
}

void CAdvCompOptions_Dlg::OnBnClickedButtonResetDefaults()
{
	// TODO: Add your control notification handler code here
	m_nCompileThreads = 4;
	m_bVerbose = FALSE;
	m_bVerboseLogged = FALSE;
	m_nSurfaceChop = 256;
	m_bOldBounds = FALSE;
	m_bVerboseEnts = FALSE;
	m_bVerboseBrushes = FALSE;
	m_bNoWeld = FALSE;
	m_bNoCSG = FALSE;
	m_bNoShare = FALSE;
	m_bNotJunc = FALSE;
	m_bNoWater = FALSE;
	m_bNoOpt = FALSE;
	m_bNoPrune = FALSE;
	m_bNoMerge = FALSE;
	m_bNoSubdiv = FALSE;
	m_bNoDetail = FALSE;
	m_bFullDetail = FALSE;
	m_bNoHints = FALSE;
	m_bQBSP_GLView = FALSE;
	m_bVisNoSort = FALSE;
	m_nRadBounces = 8;
	m_nRadChop = (m_bFastCompile) ? 1024 : 128;	// Fast compile options have default patch size of 1024
	m_fRadScale = 1;
	m_fRadSurfScale = 1;
	m_fRadEntScale = 1;
	m_fRadAmbient = 0;
	m_fRadMaxlight = 0;
	m_bRadExtra = FALSE;
	m_bRadNoPVS = FALSE;
	m_bRadDumpPatches = FALSE;
	m_bRadGLView = FALSE;
	m_nRadChopSky = 0;
	m_nRadChopWarp = 0;
	m_nRadChopLight = 0;
	m_nRadChopCurve = 0;
	m_nRadAmbientAbs = 0;
	m_nRadMaxlightAbs = 0;
	m_fRadRadmin = 0;
	m_bRadNoColor = FALSE;
	m_bRadNoColorU = FALSE;
	m_bRadNoMinlimit = FALSE;
	m_bRadNoBModLight = FALSE;
	m_bRadNoStopBleed = FALSE;
	m_bRadNoCurve = FALSE;
	m_bRadNoSplotchFix = FALSE;
	m_bRadOnlyBounce = FALSE;

	UpdateData(false);	
}

