#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "NumericEdit.h"


// CAdvCompOptions_Dlg dialog

class CAdvCompOptions_Dlg : public CDialog
{
	DECLARE_DYNAMIC(CAdvCompOptions_Dlg)

public:
	CAdvCompOptions_Dlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CAdvCompOptions_Dlg();

// Dialog Data
	enum { IDD = IDD_ADV_COMP_OPTIONS_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	CToolTipCtrl m_ToolTip;
	BOOL PreTranslateMessage(MSG *pMsg);
	// Generated message map functions
	virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()
public:
	BOOL m_bFastCompile;
	CEdit m_ctlEditCompileThreads;
	CSpinButtonCtrl m_ctlSpinCompileThreads;
	int m_nCompileThreads;
	CButton m_ctlCheckVerbose;
	BOOL m_bVerbose;
	CButton m_ctlCheckVerboseLogged;
	BOOL m_bVerboseLogged;
	CEdit m_ctlEditSurfaceChop;
	CSpinButtonCtrl m_ctlSpinSurfaceChop;
	int m_nSurfaceChop;
	afx_msg void OnDeltaposSpinSurfacechop(NMHDR *pNMHDR, LRESULT *pResult);
	CButton m_ctlCheckOldBounds;
	BOOL m_bOldBounds;
	CButton m_ctlCheckVerboseEnts;
	BOOL m_bVerboseEnts;
	CButton m_ctlCheckVerboseBrushes;
	BOOL m_bVerboseBrushes;
	CButton m_ctlCheckNoWeld;
	BOOL m_bNoWeld;
	CButton m_ctlCheckNoCSG;
	BOOL m_bNoCSG;
	CButton m_ctlCheckNoShare;
	BOOL m_bNoShare;
	CButton m_ctlCheckNotJunc;
	BOOL m_bNotJunc;
	CButton m_ctlCheckNoWater;
	BOOL m_bNoWater;
	CButton m_ctlCheckNoOpt;
	BOOL m_bNoOpt;
	CButton m_ctlCheckNoPrune;
	BOOL m_bNoPrune;
	CButton m_ctlCheckNoMerge;
	BOOL m_bNoMerge;
	CButton m_ctlCheckNoSubdiv;
	BOOL m_bNoSubdiv;
	CButton m_ctlCheckNoDetail;
	BOOL m_bNoDetail;
	CButton m_ctlCheckFullDetail;
	BOOL m_bFullDetail;
	CButton m_ctlCheckNoHints;
	BOOL m_bNoHints;
	CButton m_ctlCheckQBSP_GLView;
	BOOL m_bQBSP_GLView;
	CButton m_ctlCheckVisNoSort;
	BOOL m_bVisNoSort;
	CEdit m_ctlEditRadBounces;
	CSpinButtonCtrl m_ctlSpinRadBounces;
	int m_nRadBounces;
	CEdit m_ctlEditRadChop;
	CSpinButtonCtrl m_ctlSpinRadChop;
	int m_nRadChop;
	afx_msg void OnDeltaposSpinRadChop(NMHDR *pNMHDR, LRESULT *pResult);
	CNumericEdit m_ctlEditRadScale;
	CSpinButtonCtrl m_ctlSpinRadScale;
	float m_fRadScale;
	afx_msg void OnDeltaposSpinRadScale(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeEditRadScale();
	CNumericEdit m_ctlEditRadSurfScale;
	CSpinButtonCtrl m_ctlSpinRadSurfScale;
	float m_fRadSurfScale;
	afx_msg void OnDeltaposSpinRadSurfscale(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeEditRadSurfscale();
	CNumericEdit m_ctlEditRadEntScale;
	CSpinButtonCtrl m_ctlSpinRadEntScale;
	float m_fRadEntScale;
	afx_msg void OnDeltaposSpinRadEntscale(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeEditRadEntscale();
	CNumericEdit m_ctlEditRadAmbient;
	CSpinButtonCtrl m_ctlSpinRadAmbient;
	float m_fRadAmbient;
	afx_msg void OnDeltaposSpinRadAmbient(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeEditRadAmbient();
	CNumericEdit m_ctlEditRadMaxlight;
	CSpinButtonCtrl m_ctlSpinRadMaxlight;
	float m_fRadMaxlight;
	afx_msg void OnDeltaposSpinRadMaxlight(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeEditRadMaxlight();
	CButton m_ctlCheckRadExtra;
	BOOL m_bRadExtra;
	CButton m_ctlCheckRadNoPVS;
	BOOL m_bRadNoPVS;
	CButton m_ctlCheckRadDumpPatches;
	BOOL m_bRadDumpPatches;
	CButton m_ctlCheckRadGLView;
	BOOL m_bRadGLView;
	CEdit m_ctlEditRadChopSky;
	CSpinButtonCtrl m_ctlSpinRadChopSky;
	int m_nRadChopSky;
	afx_msg void OnDeltaposSpinRadChopsky(NMHDR *pNMHDR, LRESULT *pResult);
	CEdit m_ctlEditRadChopWarp;
	CSpinButtonCtrl m_ctlSpinRadChopWarp;
	int m_nRadChopWarp;
	afx_msg void OnDeltaposSpinRadChopwarp(NMHDR *pNMHDR, LRESULT *pResult);
	CEdit m_ctlEditRadChopLight;
	CSpinButtonCtrl m_ctlSpinRadChopLight;
	int m_nRadChopLight;
	afx_msg void OnDeltaposSpinRadChoplight(NMHDR *pNMHDR, LRESULT *pResult);
	CEdit m_ctlEditRadChopCurve;
	CSpinButtonCtrl m_ctlSpinRadChopCurve;
	int m_nRadChopCurve;
	afx_msg void OnDeltaposSpinRadChopcurve(NMHDR *pNMHDR, LRESULT *pResult);
	CEdit m_ctlEditRadAmbientAbs;
	CSpinButtonCtrl m_ctlSpinRadAmbientAbs;
	int m_nRadAmbientAbs;
	CEdit m_ctlEditRadMaxlightAbs;
	CSpinButtonCtrl m_ctlSpinRadMaxlightAbs;
	int m_nRadMaxlightAbs;
	CNumericEdit m_ctlEditRadRadmin;
	CSpinButtonCtrl m_ctlSpinRadRadmin;
	float m_fRadRadmin;
	afx_msg void OnDeltaposSpinRadRadmin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeEditRadRadmin();
	CButton m_ctlCheckRadNoColor;
	BOOL m_bRadNoColor;
	CButton m_ctlCheckRadNoColorU;
	BOOL m_bRadNoColorU;
	CButton m_ctlCheckRadNoMinlimit;
	BOOL m_bRadNoMinlimit;
	CButton m_ctlCheckRadNoBModLight;
	BOOL m_bRadNoBModLight;
	CButton m_ctlCheckRadNoStopBleed;
	BOOL m_bRadNoStopBleed;
	CButton m_ctlEditRadNoCurve;
	BOOL m_bRadNoCurve;
	CButton m_ctlCheckRadNoSplotchFix;
	BOOL m_bRadNoSplotchFix;
	CButton m_ctlCheckRadOnlyBounce;
	BOOL m_bRadOnlyBounce;
	afx_msg void OnBnClickedButtonResetDefaults();
};
