// q2_otterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "q2_otter.h"
#include "q2_otterDlg.h"
#include "registryinterface.h"
//#include "bmpscan.h"
#include "AdvCompOptions_Dlg.h"
#include <direct.h>  
#include <sys\stat.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Cq2_otterDlg dialog

Cq2_otterDlg::Cq2_otterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cq2_otterDlg::IDD, pParent)
	, m_strMapFile(_T(""))
	, m_strModDir(_T(""))
	, m_strGameDir(_T(""))
	, m_strMapsDir(_T(""))
	, m_nCompileType(0)
	, m_nCompileThreads(4)
	, m_bVerbose(FALSE)
	, m_bVerboseLogged(FALSE)
	, m_nSurfaceChop(256)
	, m_bOldBounds(FALSE)
	, m_bVerboseEnts(FALSE)
	, m_bVerboseBrushes(FALSE)
	, m_bNoWeld(FALSE)
	, m_bNoCSG(FALSE)
	, m_bNoShare(FALSE)
	, m_bNotJunc(FALSE)
	, m_bNoWater(FALSE)
	, m_bNoOpt(FALSE)
	, m_bNoPrune(FALSE)
	, m_bNoMerge(FALSE)
	, m_bNoSubdiv(FALSE)
	, m_bNoDetail(FALSE)
	, m_bFullDetail(FALSE)
	, m_bNoHints(FALSE)
	, m_bQBSP_GLView(FALSE)
	, m_bVisNoSort(FALSE)
	, m_nRadBounces(1)
	, m_nRadChop(128)
	, m_fRadScale(1)
	, m_fRadSurfScale(1)
	, m_fRadEntScale(1)
	, m_fRadAmbient(0)
	, m_fRadMaxlight(0)
	, m_bRadExtra(FALSE)
	, m_bRadNoPVS(FALSE)
	, m_bRadDumpPatches(FALSE)
	, m_bRadGLView(FALSE)
	, m_nRadChopSky(0)
	, m_nRadChopWarp(0)
	, m_nRadChopLight(0)
	, m_nRadChopCurve(0)
	, m_nRadAmbientAbs(0)
	, m_nRadMaxlightAbs(0)
	, m_fRadRadmin(0)
	, m_bRadNoColor(FALSE)
	, m_bRadNoColorU(FALSE)
	, m_bRadNoMinlimit(FALSE)
	, m_bRadNoBModLight(FALSE)
	, m_bRadNoStopBleed(FALSE)
	, m_bRadNoCurve(FALSE)
	, m_bRadNoSplotchFix(FALSE)
	, m_bRadOnlyBounce(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cq2_otterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_MAPFILE, m_strMapFile);
	DDX_Text(pDX, IDC_EDIT_RADSCALE, m_fRadScale);
	DDX_Text(pDX, IDC_EDIT_RADBOUNCES, m_nRadBounces);
	DDV_MinMaxInt(pDX, m_nRadBounces, 0, 16);
	DDV_MaxChars(pDX, m_strMapFile, 1023);
	DDX_Text(pDX, IDC_EDIT_MODDIR, m_strModDir);
	DDX_Text(pDX, IDC_EDIT_GAMEDIR, m_strGameDir);
	DDX_Text(pDX, IDC_EDIT_MAPSDIR, m_strMapsDir);
	DDX_Radio(pDX, IDC_RADIO_COMPILE_FULL_ARGHRAD, m_nCompileType);
	DDX_Text(pDX, IDC_EDIT_THREADS, m_nCompileThreads);
	DDV_MinMaxInt(pDX, m_nCompileThreads, 1, 64);
	DDX_Control(pDX, IDC_SPIN_THREADS, m_ctlSpinThreads);
	DDX_Control(pDX, IDC_SPIN_RADSCALE, m_ctlSpinRadScale);
	DDX_Control(pDX, IDC_SPIN_RADBOUNCES, m_ctlSpinRadBounces);
	DDX_Control(pDX, IDC_SPIN_SURFACECHOP, m_ctlSpinSurfaceChop);
	DDX_Control(pDX, IDC_EDIT_SURFACECHOP, m_ctlEditSurfaceChop);
	DDX_Text(pDX, IDC_EDIT_SURFACECHOP, m_nSurfaceChop);
	DDV_MinMaxInt(pDX, m_nSurfaceChop, 240, 1024);
	DDX_Control(pDX, IDC_EDIT_GAMEDIR, m_ctlEditGameDir);
	DDX_Control(pDX, IDC_EDIT_MODDIR, m_ctlEditModDir);
	DDX_Control(pDX, IDC_EDIT_MAPSDIR, m_ctlEditMapsDir);
	DDX_Control(pDX, IDC_EDIT_MAPFILE, m_ctlEditMapFile);
	DDX_Control(pDX, IDC_EDIT_THREADS, m_ctlEditCompileThreads);
	DDX_Control(pDX, IDC_EDIT_RADSCALE, m_ctlEditRadScale);
	DDX_Control(pDX, IDC_EDIT_RADBOUNCES, m_ctlEditRadBounces);
	DDX_Control(pDX, IDC_BUTTON_CONFIGURE_COPY_FILES, m_ctlButtonConfigureCopyFiles);
}

BEGIN_MESSAGE_MAP(Cq2_otterDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
//	ON_EN_CHANGE(IDC_EDIT_TEXTUREDIR, &Cq2_otterDlg::OnEnChangeEditTexturedir)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_MAP, &Cq2_otterDlg::OnBnClickedButtonBrowseMap)
//	ON_BN_CLICKED(IDC_BUTTON_BROWSE_TEXTUREDIR, &Cq2_otterDlg::OnBnClickedButtonBrowseTextureDir)
	ON_BN_CLICKED(IDC_BUTTON_COMPILEMAP, &Cq2_otterDlg::OnBnClickedButtonCompileMap)
//	ON_BN_CLICKED(IDC_BUTTON_MAKEWALS, &Cq2_otterDlg::OnBnClickedButtonMakeWals)
//	ON_BN_CLICKED(IDC_BUTTON_OPEN_TEXTUREDIR, &Cq2_otterDlg::OnBnClickedButtonOpenTexturedir)
	ON_EN_CHANGE(IDC_EDIT_MAPFILE, &Cq2_otterDlg::OnEnChangeEditMapFile)
	ON_EN_CHANGE(IDC_EDIT_RADSCALE, &Cq2_otterDlg::OnEnChangeEditRadScale)
	ON_EN_CHANGE(IDC_EDIT_RADBOUNCES, &Cq2_otterDlg::OnEnChangeEditRadBounces)
	ON_EN_CHANGE(IDC_EDIT_GAMEDIR, &Cq2_otterDlg::OnEnChangeEditGameDir)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_GAMEDIR, &Cq2_otterDlg::OnBnClickedButtonBrowseGameDir)
	ON_EN_CHANGE(IDC_EDIT_MAPSDIR, &Cq2_otterDlg::OnEnChangeEditMapsDir)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_MAPSDIR, &Cq2_otterDlg::OnBnClickedButtonBrowseMapsDir)
	ON_EN_CHANGE(IDC_EDIT_MODDIR, &Cq2_otterDlg::OnEnChangeEditModDir)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_MODDIR, &Cq2_otterDlg::OnBnClickedButtonBrowseModDir)
	ON_EN_CHANGE(IDC_EDIT_THREADS, &Cq2_otterDlg::OnEnChangeEditThreads)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_THREADS, &Cq2_otterDlg::OnDeltaposSpinThreads)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RADSCALE, &Cq2_otterDlg::OnDeltaposSpinRadScale)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RADBOUNCES, &Cq2_otterDlg::OnDeltaposSpinRadBounces)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_SURFACECHOP, &Cq2_otterDlg::OnDeltaposSpinSurfaceChop)
	ON_BN_CLICKED(IDC_BUTTON_ADV_COMP_OPTIONS, &Cq2_otterDlg::OnBnClickedButtonAdvCompOptions)
	ON_BN_CLICKED(IDC_RADIO_COMPILE_FULL_ARGHRAD, &Cq2_otterDlg::OnBnClickedRadioCompileType)
	ON_BN_CLICKED(IDC_RADIO_COMPILE_FULL_QRAD, &Cq2_otterDlg::OnBnClickedRadioCompileType)
	ON_BN_CLICKED(IDC_RADIO_COMPILE_FAST_ARGHRAD, &Cq2_otterDlg::OnBnClickedRadioCompileType)
	ON_BN_CLICKED(IDC_RADIO_COMPILE_FAST_QRAD, &Cq2_otterDlg::OnBnClickedRadioCompileType)
	ON_BN_CLICKED(IDC_RADIO_COMPILE_RELIGHT_ARGHRAD, &Cq2_otterDlg::OnBnClickedRadioCompileType)
	ON_BN_CLICKED(IDC_RADIO_COMPILE_RELIGHT_QRAD, &Cq2_otterDlg::OnBnClickedRadioCompileType)
	ON_BN_CLICKED(IDC_RADIO_COMPILE_ENTSONLY, &Cq2_otterDlg::OnBnClickedRadioCompileType)
	ON_BN_CLICKED(IDC_RADIO_COMPILE_LEAKTEST, &Cq2_otterDlg::OnBnClickedRadioCompileType)
	ON_BN_CLICKED(IDC_BUTTON_CONFIGURE_COPY_FILES, &Cq2_otterDlg::OnBnClickedButtonConfigureCopyFiles)
END_MESSAGE_MAP()


// Cq2_otterDlg message handlers

BOOL Cq2_otterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	GetCurrentDirectory(MAX_PATH, m_szCurrentPath);

	m_ctlSpinThreads.SetRange(1, 64);
	m_ctlSpinSurfaceChop.SetRange(240, 1024);
	m_ctlSpinRadScale.SetRange(1, 200);
	m_ctlSpinRadScale.SetPos(20);
	m_ctlEditRadScale.SetLimitText(4);
	m_ctlEditRadScale.m_bAllowNegativeValues = false;
	m_ctlSpinRadBounces.SetRange(0, 16);

	GetDlgItem(IDC_BUTTON_COMPILEMAP)->EnableWindow(m_strMapFile != _T(""));

	// Create ToolTip
	if ( !m_ToolTip.Create(this) )
	{
		MessageBox("Couldn't create tooltip.", "Error", MB_OK | MB_ICONERROR);
	}
	else
	{
		// Add tool tips to controls
		m_ToolTip.AddTool (&m_ctlEditGameDir, _T("The path to Quake2's baseq2 folder, e.g. C:\\Quake2\\baseq2"));
		m_ToolTip.AddTool (&m_ctlEditModDir, _T("The path to the Quake2 mod folder (optional), e.g. C:\\Quake2\\mymod  Compiled maps and textures will be copied here instead of Quake2's baseq2 folder."));
		m_ToolTip.AddTool (&m_ctlEditMapsDir, _T("The path to the map editing folder, e.g. C:\\Quake2\\mymod\\maps"));
		m_ToolTip.AddTool (&m_ctlEditMapFile, _T("The path to the map or region file to compile, e.g. C:\\Quake2\\mymod\\maps\\mymap.map"));
		m_ToolTip.AddTool (&m_ctlButtonConfigureCopyFiles, _T("Sets up configuration and batch files, and copies essential editing files."));

		m_ToolTip.AddTool (&m_ctlEditCompileThreads, _T("The number of computation threads for Qvis and Qrad/ArghRad to use, this should be the number of CPU cores in your system."));
		m_ToolTip.AddTool (&m_ctlEditSurfaceChop, _T("The size of QBSP surface subdivisions, from 240 - 1024.  Larger values result in lower r_speeds."));
		m_ToolTip.AddTool (&m_ctlEditRadScale, _T("The lighting scale for Qrad/ArghRad to use, higher means brigher."));
		m_ToolTip.AddTool (&m_ctlEditRadBounces, _T("The number of radiosity bounces for Qrad/ArghRad to use, higher means light spreads further."));
	}

	LoadRegistryInfo();

	GetDlgItem(IDC_BUTTON_CONFIGURE_COPY_FILES)->EnableWindow( (m_strGameDir != _T(""))&& (m_strGameDir.GetLength() >= 4)
															&& (m_strMapsDir != _T("")) && (m_strMapsDir.GetLength() >= 4) );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cq2_otterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cq2_otterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// Knightmare added
BOOL Cq2_otterDlg::PreTranslateMessage(MSG *pMsg)
{
	m_ToolTip.RelayEvent(pMsg);
	return CDialog::PreTranslateMessage(pMsg);
}

// Knightmare added
BOOL Cq2_otterDlg::SaveRegistryInfo()
{
	CRegistryInterface regInt;

	regInt.WriteRegistryInfoString("GameDir", (LPCSTR)m_strGameDir);
	regInt.WriteRegistryInfoString("ModDir", (LPCSTR)m_strModDir);
	regInt.WriteRegistryInfoString("MapsDir", (LPCSTR)m_strMapsDir);

	regInt.WriteRegistryInfoDword("nCompileType", (DWORD)m_nCompileType);

	regInt.WriteRegistryInfoDword("nCompileThreads", (DWORD)m_nCompileThreads);
	regInt.WriteRegistryInfoDword("bVerbose", (DWORD)m_bVerbose);
	regInt.WriteRegistryInfoDword("bVerboseLogged", (DWORD)m_bVerboseLogged);

	regInt.WriteRegistryInfoDword("nSurfaceChop", (DWORD)m_nSurfaceChop);
	regInt.WriteRegistryInfoDword("bOldBounds", (DWORD)m_bOldBounds);
	regInt.WriteRegistryInfoDword("bVerboseEnts", (DWORD)m_bVerboseEnts);
	regInt.WriteRegistryInfoDword("bVerboseBrushes", (DWORD)m_bVerboseBrushes);
	regInt.WriteRegistryInfoDword("bNoWeld", (DWORD)m_bNoWeld);
	regInt.WriteRegistryInfoDword("bNoCSG", (DWORD)m_bNoCSG);
	regInt.WriteRegistryInfoDword("bNoShare", (DWORD)m_bNoShare);
	regInt.WriteRegistryInfoDword("bNotJunc", (DWORD)m_bNotJunc);
	regInt.WriteRegistryInfoDword("bNoWater", (DWORD)m_bNoWater);
	regInt.WriteRegistryInfoDword("bNoOpt", (DWORD)m_bNoOpt);
	regInt.WriteRegistryInfoDword("bNoPrune", (DWORD)m_bNoPrune);
	regInt.WriteRegistryInfoDword("bNoMerge", (DWORD)m_bNoMerge);
	regInt.WriteRegistryInfoDword("bNoSubdiv", (DWORD)m_bNoSubdiv);
	regInt.WriteRegistryInfoDword("bNoDetail", (DWORD)m_bNoDetail);
	regInt.WriteRegistryInfoDword("bFullDetail", (DWORD)m_bFullDetail);
	regInt.WriteRegistryInfoDword("bNoHints", (DWORD)m_bNoHints);
	regInt.WriteRegistryInfoDword("bQBSP_GLView", (DWORD)m_bQBSP_GLView);

	regInt.WriteRegistryInfoDword("bVisNoSort", (DWORD)m_bVisNoSort);

	regInt.WriteRegistryInfoDword("nRadBounces", (DWORD)m_nRadBounces);
	regInt.WriteRegistryInfoDword("nRadChop", (DWORD)m_nRadChop);
	regInt.WriteRegistryInfoBinary("fRadScale", (void*)&m_fRadScale, sizeof(m_fRadScale));
	regInt.WriteRegistryInfoBinary("fRadSurfScale", (void*)&m_fRadSurfScale, sizeof(m_fRadSurfScale));
	regInt.WriteRegistryInfoBinary("fRadEntScale", (void*)&m_fRadEntScale, sizeof(m_fRadEntScale));
	regInt.WriteRegistryInfoBinary("fRadAmbient", (void*)&m_fRadAmbient, sizeof(m_fRadAmbient));
	regInt.WriteRegistryInfoBinary("fRadMaxlight", (void*)&m_fRadMaxlight, sizeof(m_fRadMaxlight));
	regInt.WriteRegistryInfoDword("bRadExtra", (DWORD)m_bRadExtra);
	regInt.WriteRegistryInfoDword("bRadNoPVS", (DWORD)m_bRadNoPVS);
	regInt.WriteRegistryInfoDword("bRadDumpPatches", (DWORD)m_bRadDumpPatches);
	regInt.WriteRegistryInfoDword("bRadGLView", (DWORD)m_bRadGLView);

	regInt.WriteRegistryInfoDword("nRadChopSky", (DWORD)m_nRadChopSky);
	regInt.WriteRegistryInfoDword("nRadChopWarp", (DWORD)m_nRadChopWarp);
	regInt.WriteRegistryInfoDword("nRadChopLight", (DWORD)m_nRadChopLight);
	regInt.WriteRegistryInfoDword("nRadChopCurve", (DWORD)m_nRadChopCurve);
	regInt.WriteRegistryInfoDword("nRadAmbientAbs", (DWORD)m_nRadAmbientAbs);
	regInt.WriteRegistryInfoDword("nRadMaxlightAbs", (DWORD)m_nRadMaxlightAbs);
	regInt.WriteRegistryInfoBinary("fRadRadmin", (void*)&m_fRadRadmin, sizeof(m_fRadRadmin));
	regInt.WriteRegistryInfoDword("bRadNoColor", (DWORD)m_bRadNoColor);
	regInt.WriteRegistryInfoDword("bRadNoColorU", (DWORD)m_bRadNoColorU);
	regInt.WriteRegistryInfoDword("bRadNoMinlimit", (DWORD)m_bRadNoMinlimit);
	regInt.WriteRegistryInfoDword("bRadNoBModLight", (DWORD)m_bRadNoBModLight);
	regInt.WriteRegistryInfoDword("bRadNoStopBleed", (DWORD)m_bRadNoStopBleed);
	regInt.WriteRegistryInfoDword("bRadNoCurve", (DWORD)m_bRadNoCurve);
	regInt.WriteRegistryInfoDword("bRadNoSplotchFix", (DWORD)m_bRadNoSplotchFix);
	regInt.WriteRegistryInfoDword("bRadOnlyBounce", (DWORD)m_bRadOnlyBounce);

	return TRUE;
}

BOOL Cq2_otterDlg::LoadRegistryInfo()
{
	CRegistryInterface regInt;
	char	szTemp[MAX_PATH];
	int		temp;
	float	fTemp;
	long	bufSize;

	szTemp[0] = '\0';
	if ( regInt.ReadRegistryInfoString("GameDir", szTemp, sizeof(szTemp)) )
	{
		if (strlen(szTemp) > 0)
			m_strGameDir = szTemp;
	}
	szTemp[0] = '\0';
	if ( regInt.ReadRegistryInfoString("ModDir", szTemp, sizeof(szTemp)) )
	{
		if (strlen(szTemp) > 0)
			m_strModDir = szTemp;
	}
	szTemp[0] = '\0';
	if ( regInt.ReadRegistryInfoString("MapsDir", szTemp, sizeof(szTemp)) )
	{
		if (strlen(szTemp) > 0)
			m_strMapsDir = szTemp;
	}

	if ( regInt.ReadRegistryInfoDword("nCompileType", &temp) )
		m_nCompileType = temp;

	if ( regInt.ReadRegistryInfoDword("nCompileThreads", &temp) )
		m_nCompileThreads = temp;
	if ( regInt.ReadRegistryInfoDword("bVerbose", &temp) )
		m_bVerbose = temp;
	if ( regInt.ReadRegistryInfoDword("bVerboseLogged", &temp) )
		m_bVerboseLogged = temp;

	if ( regInt.ReadRegistryInfoDword("nSurfaceChop", &temp) )
		m_nSurfaceChop = temp;
	if ( regInt.ReadRegistryInfoDword("bOldBounds", &temp) )
		m_bOldBounds = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bVerboseEnts", &temp) )
		m_bVerboseEnts = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bVerboseBrushes", &temp) )
		m_bVerboseBrushes = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoWeld", &temp) )
		m_bNoWeld = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoCSG", &temp) )
		m_bNoCSG = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoShare", &temp) )
		m_bNoShare = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNotJunc", &temp) )
		m_bNotJunc = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoWater", &temp) )
		m_bNoWater = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoOpt", &temp) )
		m_bNoOpt = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoPrune", &temp) )
		m_bNoPrune = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoMerge", &temp) )
		m_bNoMerge = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoSubdiv", &temp) )
		m_bNoSubdiv = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoDetail", &temp) )
		m_bNoDetail = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bFullDetail", &temp) )
		m_bFullDetail = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bNoHints", &temp) )
		m_bNoHints = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bQBSP_GLView", &temp) )
		m_bQBSP_GLView = (temp != 0);

	if ( regInt.ReadRegistryInfoDword("bVisNoSort", &temp) )
		m_bVisNoSort = (temp != 0);


	if ( regInt.ReadRegistryInfoDword("nRadBounces", &temp) )
		m_nRadBounces = temp;
	if ( regInt.ReadRegistryInfoDword("nRadChop", &temp) )
		m_nRadChop = temp;
	bufSize = sizeof(m_fRadScale);
	if ( regInt.ReadRegistryInfoBinary("fRadScale", (void*)&fTemp, &bufSize) )
		m_fRadScale = fTemp;
	if ( regInt.ReadRegistryInfoBinary("fRadSurfScale", (void*)&fTemp, &bufSize) )
		m_fRadSurfScale = fTemp;
	if ( regInt.ReadRegistryInfoBinary("fRadEntScale", (void*)&fTemp, &bufSize) )
		m_fRadEntScale = fTemp;
	if ( regInt.ReadRegistryInfoBinary("fRadAmbient", (void*)&fTemp, &bufSize) )
		m_fRadAmbient = fTemp;
	if ( regInt.ReadRegistryInfoBinary("fRadMaxlight", (void*)&fTemp, &bufSize) )
		m_fRadMaxlight = fTemp;
	if ( regInt.ReadRegistryInfoDword("bRadExtra", &temp) )
		m_bRadExtra = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadNoPVS", &temp) )
		m_bRadNoPVS = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadDumpPatches", &temp) )
		m_bRadDumpPatches = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadGLView", &temp) )
		m_bRadGLView = (temp != 0);

	if ( regInt.ReadRegistryInfoDword("nRadChopSky", &temp) )
		m_nRadChopSky = temp;
	if ( regInt.ReadRegistryInfoDword("nRadChopWarp", &temp) )
		m_nRadChopWarp = temp;
	if ( regInt.ReadRegistryInfoDword("nRadChopLight", &temp) )
		m_nRadChopLight = temp;
	if ( regInt.ReadRegistryInfoDword("nRadChopCurve", &temp) )
		m_nRadChopCurve = temp;
	if ( regInt.ReadRegistryInfoDword("nRadAmbientAbs", &temp) )
		m_nRadAmbientAbs = temp;
	if ( regInt.ReadRegistryInfoDword("nRadMaxlightAbs", &temp) )
		m_nRadMaxlightAbs = temp;
	if ( regInt.ReadRegistryInfoBinary("fRadRadmin", (void*)&fTemp, &bufSize) )
		m_fRadRadmin = fTemp;
	if ( regInt.ReadRegistryInfoDword("bRadNoColor", &temp) )
		m_bRadNoColor = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadNoColorU", &temp) )
		m_bRadNoColorU = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadNoMinlimit", &temp) )
		m_bRadNoMinlimit = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadNoBModLight", &temp) )
		m_bRadNoBModLight = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadNoStopBleed", &temp) )
		m_bRadNoStopBleed = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadNoCurve", &temp) )
		m_bRadNoCurve = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadNoSplotchFix", &temp) )
		m_bRadNoSplotchFix = (temp != 0);
	if ( regInt.ReadRegistryInfoDword("bRadOnlyBounce", &temp) )
		m_bRadOnlyBounce = (temp != 0);

	UpdateData(false);

	return TRUE;
}
// end Knightmare

void Cq2_otterDlg::OnEnChangeEditMapFile()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strMapFileName;
	GetDlgItemText(IDC_EDIT_MAPFILE, strMapFileName);
	GetDlgItem(IDC_BUTTON_COMPILEMAP)->EnableWindow(strMapFileName != _T(""));
	UpdateData(true);
}

void Cq2_otterDlg::OnBnClickedButtonConfigureCopyFiles()
{
	// TODO: Add your control notification handler code here
//	CString m_strGameDir;
//	CString m_strModDir;
//	CString m_strMapsDir;
	if ( m_strGameDir != _T("") && (m_strGameDir.GetLength() >= 4) // X:\<foldername>\baseq2
		&& m_strMapsDir != _T("") && (m_strMapsDir.GetLength() >= 4)) // X:\<foldername>
	{
		// Create and execute our compile .bat file here
		char		szCmdBuf[16384];
		int			nCmdLen;
		bool		bUseModDir = false;
		CFile		batchFile;
		CString		strCurrentPath = _T(""), strGameDir = _T(""), strMapsDir = _T("");
		CString		strCommand = _T("");
		CString		strBatName, strErrMsg;

		memset (&szCmdBuf, 0, sizeof(szCmdBuf));

		strCurrentPath = m_szCurrentPath;
		if (m_strModDir != _T("")) {
			strGameDir = m_strModDir;
			bUseModDir = true;
		}
		else {
			strGameDir = m_strGameDir;
			if (strGameDir.Find("\\baseq2") != -1)
				strGameDir.GetBufferSetLength(strGameDir.ReverseFind('\\'));	// trim "\baseq2" from path
		}
		strMapsDir = m_strMapsDir;

		// build commands
		strCommand += _T("@echo off\r\n");
		strCommand += _T("echo.\r\n");
	//	strCommand += _T("SET GAMEDIR=") + strQ2DirSingleSlash + _T("\\baseq2\r\n");
		if (bUseModDir)
			strCommand += _T("SET GAMEDIR=") + strGameDir + _T("\r\n");
		else
			strCommand += _T("SET GAMEDIR=") + strGameDir + _T("\\baseq2\r\n");
		strCommand += _T("SET Q2MAPS=") + m_strMapsDir + _T("\r\n");
		strCommand += _T("\r\n");
		strCommand += _T("echo copy colormap.pcx %GAMEDIR%\r\n");
		strCommand += _T("mkdir %GAMEDIR%\\pics\r\n");
		strCommand += _T("copy colormap.pcx %GAMEDIR%\\pics\r\n");
		strCommand += _T("\r\n");
		strCommand += _T("echo copy q2_entities.def %GAMEDIR%\r\n");
		strCommand += _T("copy q2_entities.def %GAMEDIR%\r\n");
		strCommand += _T("\r\n");
		strCommand += _T("echo copy areaportal.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy caulk.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy clip.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy clip_mon.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy clip_shot.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy hint.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy ladder.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy nodraw.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy nodraw_solid.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy origin.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy skip.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("echo copy trigger.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("mkdir %GAMEDIR%\\textures\r\n");
		strCommand += _T("mkdir %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\areaportal.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\caulk.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\clip.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\clip_mon.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\clip_shot.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\hint.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\ladder.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\nodraw.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\nodraw_solid.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\origin.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\skip.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("copy files\\trigger.wal %GAMEDIR%\\textures\\common\r\n");
		strCommand += _T("\r\n");
		strCommand += _T("echo copy base1.map %Q2MAPS%\r\n");
	//	strCommand += _T("mkdir %Q2MAPS%\\example\r\n");
		strCommand += _T("copy files\\base1map.dat %Q2MAPS%\\base1.map\r\n");
		strCommand += _T("\r\n");
		strCommand += _T("echo Done.\r\n");
		strCommand += _T("echo.\r\n");
		strCommand += _T("pause\r\n");

		// copy commands to output buffer
		sprintf_s (szCmdBuf, sizeof(szCmdBuf), "%s", (LPCSTR)strCommand);
		nCmdLen = (int)strlen(szCmdBuf);

		// Open .bat file and write commands
		strBatName = strCurrentPath + _T("\\q2otter_dir.bat");

		if ( !batchFile.Open((LPCSTR)strBatName, CFile::modeCreate | CFile::modeWrite | CFile::shareExclusive) )
		{
			strErrMsg = _T("Couldn't open batch file ") + strBatName + _T(" for writing");
			MessageBox(strErrMsg, "Error", MB_OK | MB_ICONERROR);
			return;
		}

		batchFile.Write(&szCmdBuf, nCmdLen);
		batchFile.Close();

		// execute .bat file
		ShellExecute(NULL, "open", (LPCSTR)strBatName, NULL, (LPCSTR)strCurrentPath, SW_SHOWNORMAL);
	}
}

void Cq2_otterDlg::OnBnClickedButtonBrowseMap()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlgFile(
		true,
		NULL,
		NULL,
		0,
		_T("Map files(.map, .reg)|*.map;*.reg|")
		_T("|")
		);

	// Set maps folder as default open folder
	if ( m_strMapsDir.GetLength() > 0 )
		dlgFile.m_ofn.lpstrInitialDir = (LPCSTR)m_strMapsDir;

	if (dlgFile.DoModal() != IDOK)
		return;

	POSITION pos = dlgFile.GetStartPosition();

	if (pos) {
		UpdateData(true);
		m_strMapFile = dlgFile.GetNextPathName(pos);
		UpdateData(false);
	}
	GetDlgItem(IDC_BUTTON_COMPILEMAP)->EnableWindow(m_strMapFile != _T(""));
}

void Cq2_otterDlg::OnBnClickedButtonCompileMap()
{
	// TODO: Add your control notification handler code here
	if ( m_strMapFile != _T("") )
	{
		UpdateData(true);	// Get updated compile options

		// Create and execute our compile .bat file here
		char		szCmdBuf[16384];
		int			nCmdLen;
		CFile		batchFile;
		CString		strCurrentPath, strMapDir, strBSPFile;	//, strMapFileNoExt;
		CString		strCompileType = _T(""), strNumericParm = _T(""), strCommand = _T("");
		CString		strBatName, strErrMsg;
		BOOL		bQBSPOnlyEnts = false, bSkipVis = false, bSkipRad = false, bFastCompile = false, bUseArghRad = false;

		memset (&szCmdBuf, 0, sizeof(szCmdBuf));

		strCurrentPath = m_szCurrentPath;
		strMapDir = m_strMapFile;
		strMapDir.GetBufferSetLength(m_strMapFile.ReverseFind('\\'));
	//	strMapFileNoExt = m_strMapFile;
	//	strMapFileNoExt.GetBufferSetLength(m_strMapFile.ReverseFind('.'));
		strBSPFile = m_strMapFile;
		strBSPFile.GetBufferSetLength(m_strMapFile.ReverseFind('.'));
		strBSPFile += _T(".bsp");
		
		switch (m_nCompileType)
		{
		case 0:	// Full ArghRad
			bUseArghRad = true;
			// Fall through
		case 1:	// Full Qrad3
			strCompileType = _T("FULL");
			break;
		case 2:	// Fast ArghRad
			bUseArghRad = true;
			// Fall through
		case 3:	// Fast Qrad3
			strCompileType = _T("FAST");
			bFastCompile = true;
			break;
		case 4:	// Relight ArgRad
			bUseArghRad = true;
			// Fall through
		case 5:	// Relight Qrad3
			strCompileType = _T("RELIGHT");
			bQBSPOnlyEnts = true;
			bSkipVis = true;
			break;
		case 6:	// Entities Only
			strCompileType = _T("ENTS ONLY");
			bQBSPOnlyEnts = true;
			bSkipVis = true;
			bSkipRad = true;
			break;
		case 7:	 // Leaktest
			strCompileType = _T("LEAKTEST");
			bSkipVis = true;
			bSkipRad = true;
			break;
		default:
			break;
		}

		// build commands
		strCommand += _T("@echo off\r\n");
		strCommand += _T("echo .\r\n");
		strCommand += _T("echo .\r\n");
		strCommand += _T("echo .\r\n");
		strCommand += _T("echo //=========================================\r\n");
		strCommand += _T("echo //  NEW ") + strCompileType + _T(" COMPILE: ") + m_strMapFile + _T("\r\n");
		strCommand += _T("echo //=========================================\r\n");
		strCommand += _T("set STARTDATE=%DATE%\r\n");
		strCommand += _T("set STARTTIME=%TIME%\r\n");
		strCommand += _T("PATH=") + strCurrentPath + _T("\r\n");
		strCommand += _T("SET GAMEDIR=") + m_strGameDir + _T("\r\n";)

		// QBSP call
		strCommand += _T("kmqbsp3 ");

		if  ( !bQBSPOnlyEnts ) {
			strNumericParm.Format("-chop %i ", m_nSurfaceChop);
			strCommand += strNumericParm;
		}

		if ( m_bOldBounds && !bQBSPOnlyEnts )
			strCommand += _T("-oldbounds ");
		if ( m_bVerboseEnts )
			strCommand += _T("-verboseentities ");
		if ( m_bVerboseBrushes && !bQBSPOnlyEnts )
			strCommand += _T("-verbosebrushes ");
		if (m_bNoWeld && !bQBSPOnlyEnts )
			strCommand += _T("-noweld ");
		if (m_bNoCSG && !bQBSPOnlyEnts )
			strCommand += _T("-nocsg ");
		if (m_bNoShare && !bQBSPOnlyEnts )
			strCommand += _T("-noshare ");
		if (m_bNotJunc && !bQBSPOnlyEnts )
			strCommand += _T("-notjunc ");
		if (m_bNoWater && !bQBSPOnlyEnts )
			strCommand += _T("-nowater ");
		if (m_bNoOpt && !bQBSPOnlyEnts )
			strCommand += _T("-noopt ");
		if (m_bNoPrune && !bQBSPOnlyEnts )
			strCommand += _T("-noprune ");
		if (m_bNoMerge && !bQBSPOnlyEnts )
			strCommand += _T("-nomerge ");
		if (m_bNoSubdiv && !bQBSPOnlyEnts )
			strCommand += _T("-nosubdiv ");
		if (m_bNoDetail && !bQBSPOnlyEnts )
			strCommand += _T("-nodetail ");
		if (m_bFullDetail && !bQBSPOnlyEnts )
			strCommand += _T("-fulldetail ");
		if (m_bNoHints && !bQBSPOnlyEnts )
			strCommand += _T("-nohints ");
		if (m_bQBSP_GLView && !bQBSPOnlyEnts )
			strCommand += _T("-glview ");

		if ( bQBSPOnlyEnts )
			strCommand += _T("-onlyents ");
		else if ( m_nCompileType == 7 )
			strCommand += _T("-leaktest ");

		if (m_bVerboseLogged)
			strCommand += _T("-l ");
		else if (m_bVerbose)
			strCommand += _T("-v ");

		if ( m_strModDir != _T("") )
			strCommand += _T("-moddir ") + m_strModDir + _T(" ");

		strCommand += m_strMapFile + _T("\r\n");

		// QVIS call
		if ( !bSkipVis )
		{
			strCommand += _T("qvis3 ");

			strNumericParm.Format("-threads %i ", m_nCompileThreads);
			strCommand += strNumericParm;

			if ( bFastCompile )
				strCommand += _T("-fast ");
			else
				strCommand += _T("-level 3 ");

			if (m_bVisNoSort)
				strCommand += _T("-nosort ");

			if (m_bVerboseLogged)
				strCommand += _T("-l ");
			else if (m_bVerbose)
				strCommand += _T("-v ");

			strCommand += m_strMapFile + _T("\r\n");
		}

		// QRAD call
		if ( !bSkipRad )
		{
			if ( bUseArghRad )	// ArghRad compiles are options 0, 2, 4
				strCommand += _T("arghrad202 ");
			else
				strCommand += _T("qrad3 ");

			strNumericParm.Format("-threads %i ", m_nCompileThreads);
			strCommand += strNumericParm;

			strNumericParm.Format("-bounce %i ", m_nRadBounces);
			strCommand += strNumericParm;

			strNumericParm.Format("-chop %i ", m_nRadChop);
			strCommand += strNumericParm;

			if (m_fRadScale != 1.0f)
			{
				strNumericParm.Format("-scale %.2f ", m_fRadScale);
				strCommand += strNumericParm;
			}

			if (m_fRadSurfScale != 1.0f)
			{
				strNumericParm.Format("-direct %.2f ", m_fRadSurfScale);
				strCommand += strNumericParm;
			}

			if (m_fRadEntScale != 1.0f)
			{
				strNumericParm.Format("-entity %.2f ", m_fRadEntScale);
				strCommand += strNumericParm;
			}

			if ( (m_fRadAmbient > 0.0f) && !(bUseArghRad && (m_nRadAmbientAbs > 0)) )
			{
				strNumericParm.Format("-ambient %.2f ", m_fRadAmbient);
				strCommand += strNumericParm;
			}

			if ( (m_fRadMaxlight > 0.0f) && !(bUseArghRad && (m_nRadMaxlightAbs > 0)) )
			{
				strNumericParm.Format("-maxlight %.2f ", m_fRadMaxlight);
				strCommand += strNumericParm;
			}

			if (m_bRadExtra)
				strCommand += _T("-extra ");
			if (m_bRadNoPVS)
				strCommand += _T("-nopvs ");
			if (m_bRadDumpPatches)
				strCommand += _T("-dump ");
			if (m_bRadGLView)
				strCommand += _T("-glview ");

			if (bUseArghRad)	// ArghRad-only paramaters
			{
				if (m_nRadChopSky > 0)
				{
					strNumericParm.Format("-chopsky %i ", m_nRadChopSky);
					strCommand += strNumericParm;
				}

				if (m_nRadChopWarp > 0)
				{
					strNumericParm.Format("-chopwarp %i ", m_nRadChopWarp);
					strCommand += strNumericParm;
				}

				if (m_nRadChopLight > 0)
				{
					strNumericParm.Format("-choplight %i ", m_nRadChopLight);
					strCommand += strNumericParm;
				}

				if (m_nRadChopCurve > 0)
				{
					strNumericParm.Format("-chopcurve %i ", m_nRadChopCurve);
					strCommand += strNumericParm;
				}

				if (m_nRadAmbientAbs > 0)
				{
					strNumericParm.Format("-ambienta %i ", m_nRadAmbientAbs);
					strCommand += strNumericParm;
				}

				if (m_nRadMaxlightAbs > 0)
				{
					strNumericParm.Format("-maxlighta %i ", m_nRadMaxlightAbs);
					strCommand += strNumericParm;
				}

				if (m_fRadRadmin > 0.0f)
				{
					strNumericParm.Format("-radmin %.3f ", m_fRadRadmin);
					strCommand += strNumericParm;
				}

				if (m_bRadNoColor && !m_bRadNoColorU)
					strCommand += _T("-nocolor ");
				else if (m_bRadNoColorU)
					strCommand += _T("-nocoloru ");

				if (m_bRadNoMinlimit)
					strCommand += _T("-nominlimit ");

				if (m_bRadNoBModLight)
					strCommand += _T("-nobmodlight ");

				if (m_bRadNoStopBleed)
					strCommand += _T("-nostopbleed ");

				if (m_bRadNoCurve)
					strCommand += _T("-nocurve ");

				if (m_bRadNoSplotchFix)
					strCommand += _T("-nosplotchfix ");

				if (m_bRadOnlyBounce)
					strCommand += _T("-onlybounce ");
			}

			if (m_bVerboseLogged)
				strCommand += _T("-l ");
			else if (m_bVerbose)
				strCommand += _T("-v ");

			if ( m_strModDir != _T("") )
				strCommand += _T("-moddir ") + m_strModDir + _T(" ");

			strCommand += m_strMapFile + _T("\r\n");
		}

		// Copy command
		// Only do this if maps path != moddir or gamedir
		if ( m_strModDir != _T("") )
		{
			if ( (m_strModDir + _T("\\maps")) != m_strMapsDir) {
				strCommand += _T("mkdir ") + m_strModDir + _T("\\maps\r\n");
				strCommand += _T("copy ") + strBSPFile + _T(" ") + m_strModDir + _T("\\maps\r\n");
			}
		}
		else
		{
			if ( (m_strGameDir + _T("\\maps")) != m_strMapsDir) {
				strCommand += _T("mkdir ") + m_strGameDir + _T("\\maps\r\n");
				strCommand += _T("copy ") + strBSPFile + _T(" ") + m_strGameDir + _T("\\maps\r\n");
			}
		}

		strCommand += _T("echo .\r\n");
		strCommand += _T("echo . ") + strCompileType + _T(" COMPILE FINISHED!\r\n");
		strCommand += _T("echo . Started at: %STARTDATE% - %STARTTIME%\r\n");
		strCommand += _T("echo . Ended at: %DATE% - %TIME%\r\n");
		strCommand += _T("echo .\r\n");
		strCommand += _T("pause\r\n");

		// copy commands to output buffer
		sprintf_s (szCmdBuf, sizeof(szCmdBuf), "%s", (LPCSTR)strCommand);
		nCmdLen = (int)strlen(szCmdBuf);

		// Open .bat file and write commands
		strBatName = strMapDir + _T("\\q2otter_map.bat");

		if ( !batchFile.Open((LPCSTR)strBatName, CFile::modeCreate | CFile::modeWrite | CFile::shareExclusive) )
		{
			strErrMsg = _T("Couldn't open batch file ") + strBatName + _T(" for writing");
			MessageBox(strErrMsg, "Error", MB_OK | MB_ICONERROR);
			return;
		}

		batchFile.Write(&szCmdBuf, nCmdLen);
		batchFile.Close();

		// execute .bat file
		ShellExecute(NULL, "open", (LPCSTR)strBatName, NULL, (LPCSTR)strMapDir, SW_SHOWNORMAL);
	}
}

void Cq2_otterDlg::OnEnChangeEditGameDir()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strGameDirName, strMapsDirName;
	GetDlgItemText(IDC_EDIT_GAMEDIR, strGameDirName);
	GetDlgItemText(IDC_EDIT_MAPSDIR, strMapsDirName);
	GetDlgItem(IDC_BUTTON_CONFIGURE_COPY_FILES)->EnableWindow( (strGameDirName != _T("")) && (strGameDirName.GetLength() >= 4) && (strMapsDirName != _T("")) && (strMapsDirName.GetLength() >= 4) );
	UpdateData(true);
}

void Cq2_otterDlg::OnBnClickedButtonBrowseGameDir()
{
	// TODO: Add your control notification handler code here
	BROWSEINFO		bi;
	TCHAR			szDispName[MAX_PATH];
	TCHAR			szPathName[MAX_PATH];
	LPITEMIDLIST	pidl = NULL;
	CString			strRootDir;

	szDispName[0] = '\0';
	ZeroMemory(&bi, sizeof(bi));
	bi.hwndOwner = NULL;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szDispName;
	bi.lpszTitle = _T("Select the Quake2 baseq2 folder:");
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lParam = NULL;
	bi.iImage = 0;
	
	if ( strlen(m_szCurrentPath) > 0 )	// Set folder above "DKtools" as start folder
	{
		strRootDir = m_szCurrentPath;
		strRootDir.GetBufferSetLength(strRootDir.ReverseFind('\\')+1);
		bi.lpfn = SetStartBrowseDirProc;
		bi.lParam = (LPARAM)(strRootDir.GetBuffer(1));
	}

	pidl = SHBrowseForFolder(&bi);
	if (pidl != NULL)
	{
		BOOL bGotPath = SHGetPathFromIDList(pidl, szPathName);
		if (bGotPath == FALSE)
			return;

		UpdateData(true);
		m_strGameDir = szPathName;
		UpdateData(false);

		// update Configure & Copy Files button
		CString	strGameDirName, strMapsDirName;
		GetDlgItemText(IDC_EDIT_GAMEDIR, strGameDirName);
		GetDlgItemText(IDC_EDIT_MAPSDIR, strMapsDirName);
		GetDlgItem(IDC_BUTTON_CONFIGURE_COPY_FILES)->EnableWindow( (strGameDirName != _T("")) && (strGameDirName.GetLength() >= 4) && (strMapsDirName != _T("")) && (strMapsDirName.GetLength() >= 4) );
	}
}

void Cq2_otterDlg::OnEnChangeEditModDir()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(true);
}

void Cq2_otterDlg::OnBnClickedButtonBrowseModDir()
{
	// TODO: Add your control notification handler code here
	BROWSEINFO		bi;
	TCHAR			szDispName[MAX_PATH];
	TCHAR			szPathName[MAX_PATH];
	LPITEMIDLIST	pidl = NULL;
	CString			strRootDir;

	szDispName[0] = '\0';
	ZeroMemory(&bi, sizeof(bi));
	bi.hwndOwner = NULL;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szDispName;
	bi.lpszTitle = _T("Select the Quake2 mod folder:");
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lParam = NULL;
	bi.iImage = 0;

	if ( m_strGameDir.GetLength() > 0 )	// Set Quake2 folder above gamedir as start folder
	{
		strRootDir = m_strGameDir;
		strRootDir.GetBufferSetLength(strRootDir.ReverseFind('\\')+1);
		bi.lpfn = SetStartBrowseDirProc;
		bi.lParam = (LPARAM)(strRootDir.GetBuffer(1));
	}
	else if ( strlen(m_szCurrentPath) > 0 )	// Set folder above "Q2Radiant" as start folder
	{
		strRootDir = m_szCurrentPath;
		strRootDir.GetBufferSetLength(strRootDir.ReverseFind('\\')+1);
		bi.lpfn = SetStartBrowseDirProc;
		bi.lParam = (LPARAM)(strRootDir.GetBuffer(1));
	}

	pidl = SHBrowseForFolder(&bi);
	if (pidl != NULL)
	{
		BOOL bGotPath = SHGetPathFromIDList(pidl, szPathName);
		if (bGotPath == FALSE)
			return;

		UpdateData(true);
		m_strModDir = szPathName;
		UpdateData(false);
	}
}

void Cq2_otterDlg::OnEnChangeEditMapsDir()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strGameDirName, strMapsDirName;
	GetDlgItemText(IDC_EDIT_GAMEDIR, strGameDirName);
	GetDlgItemText(IDC_EDIT_MAPSDIR, strMapsDirName);
	GetDlgItem(IDC_BUTTON_CONFIGURE_COPY_FILES)->EnableWindow( (strGameDirName != _T("")) && (strGameDirName.GetLength() >= 4) && (strMapsDirName != _T("")) && (strMapsDirName.GetLength() >= 4) );
	UpdateData(true);
}

void Cq2_otterDlg::OnBnClickedButtonBrowseMapsDir()
{
	// TODO: Add your control notification handler code here
	BROWSEINFO		bi;
	TCHAR			szDispName[MAX_PATH];
	TCHAR			szPathName[MAX_PATH];
	LPITEMIDLIST	pidl = NULL;

	szDispName[0] = '\0';
	ZeroMemory(&bi, sizeof(bi));
	bi.hwndOwner = NULL;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szDispName;
	bi.lpszTitle = _T("Select the root maps folder:");
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lParam = NULL;
	bi.iImage = 0;
	// Set "Q2Radiant" folder as start folder
	if ( strlen(m_szCurrentPath) > 0 ) {
		bi.lpfn = SetStartBrowseDirProc;
		bi.lParam = (LPARAM)(m_szCurrentPath);
	}

	pidl = SHBrowseForFolder(&bi);
	if (pidl != NULL)
	{
		BOOL bGotPath = SHGetPathFromIDList(pidl, szPathName);
		if (bGotPath == FALSE)
			return;

		UpdateData(true);
		m_strMapsDir = szPathName;
		UpdateData(false);

		// update Configure & Copy Files button
		CString	strGameDirName, strMapsDirName;
		GetDlgItemText(IDC_EDIT_GAMEDIR, strGameDirName);
		GetDlgItemText(IDC_EDIT_MAPSDIR, strMapsDirName);
		GetDlgItem(IDC_BUTTON_CONFIGURE_COPY_FILES)->EnableWindow( (strGameDirName != _T("")) && (strGameDirName.GetLength() >= 4) && (strMapsDirName != _T("")) && (strMapsDirName.GetLength() >= 4) );
	}
}

void Cq2_otterDlg::OnBnClickedRadioCompileType()
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	// set m_nRadChop here, as it's dependent on compile type
	// fast compile uses -chop 1024, else 128
	if (m_nCompileType == 2 || m_nCompileType == 3)
		m_nRadChop = 1024;
	else
		m_nRadChop = 128;
}

void Cq2_otterDlg::OnEnChangeEditThreads()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

void Cq2_otterDlg::OnDeltaposSpinThreads(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	*pResult = 0;
}

void Cq2_otterDlg::OnDeltaposSpinSurfaceChop(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_nSurfaceChop -= 16;
	}
	else	// increment
	{
		m_nSurfaceChop += 16;
	}
	m_nSurfaceChop = max(m_nSurfaceChop, 240);
	m_nSurfaceChop = min(m_nSurfaceChop, 1024);
	UpdateData(false);

	*pResult = 0;
}

void Cq2_otterDlg::OnDeltaposSpinRadScale(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if (pNMUpDown->iDelta == -1)	// decrement
	{
		m_fRadScale -= 0.05f;
	}
	else	// increment
	{
		m_fRadScale += 0.05f;
	}
	m_fRadScale = max(m_fRadScale, 0.05f);
	m_fRadScale = min(m_fRadScale, 10.0f);
	UpdateData(false);

	*pResult = 0;
}

void Cq2_otterDlg::OnEnChangeEditRadScale()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	CString	strRadScale;
	GetDlgItemText(IDC_EDIT_RADSCALE, strRadScale);

	m_fRadScale = (float)atof((LPCSTR)strRadScale);

	UpdateData(true);	
}

void Cq2_otterDlg::OnDeltaposSpinRadBounces(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	*pResult = 0;
}

void Cq2_otterDlg::OnEnChangeEditRadBounces()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
//	UpdateData(true);
}

void Cq2_otterDlg::OnBnClickedButtonAdvCompOptions()
{
	// TODO: Add your control notification handler code here
	CAdvCompOptions_Dlg advOptDlg;

	UpdateData(true);
	
	// set child dialog variables
	advOptDlg.m_bFastCompile = (m_nCompileType == 2 || m_nCompileType == 3) ? TRUE : FALSE;
	advOptDlg.m_nCompileThreads = m_nCompileThreads;
	advOptDlg.m_bVerbose = m_bVerbose;
	advOptDlg.m_bVerboseLogged = m_bVerboseLogged;
	advOptDlg.m_nSurfaceChop = m_nSurfaceChop;
	advOptDlg.m_bOldBounds = m_bOldBounds;
	advOptDlg.m_bVerboseEnts = m_bVerboseEnts;
	advOptDlg.m_bVerboseBrushes = m_bVerboseBrushes;
	advOptDlg.m_bNoWeld = m_bNoWeld;
	advOptDlg.m_bNoCSG = m_bNoCSG;
	advOptDlg.m_bNoShare = m_bNoShare;
	advOptDlg.m_bNotJunc = m_bNotJunc;
	advOptDlg.m_bNoWater = m_bNoWater;
	advOptDlg.m_bNoOpt = m_bNoOpt;
	advOptDlg.m_bNoPrune = m_bNoPrune;
	advOptDlg.m_bNoMerge = m_bNoMerge;
	advOptDlg.m_bNoSubdiv = m_bNoSubdiv;
	advOptDlg.m_bNoDetail = m_bNoDetail;
	advOptDlg.m_bFullDetail = m_bFullDetail;
	advOptDlg.m_bNoHints = m_bNoHints;
	advOptDlg.m_bQBSP_GLView = m_bQBSP_GLView;
	advOptDlg.m_bVisNoSort = m_bVisNoSort;
	advOptDlg.m_nRadBounces = m_nRadBounces;
	advOptDlg.m_nRadChop = m_nRadChop;
	advOptDlg.m_fRadScale = m_fRadScale;
	advOptDlg.m_fRadSurfScale = m_fRadSurfScale;
	advOptDlg.m_fRadEntScale = m_fRadEntScale;
	advOptDlg.m_fRadAmbient = m_fRadAmbient;
	advOptDlg.m_fRadMaxlight = m_fRadMaxlight;
	advOptDlg.m_bRadExtra = m_bRadExtra;
	advOptDlg.m_bRadNoPVS = m_bRadNoPVS;
	advOptDlg.m_bRadDumpPatches = m_bRadDumpPatches;
	advOptDlg.m_bRadGLView = m_bRadGLView;
	advOptDlg.m_nRadChopSky = m_nRadChopSky;
	advOptDlg.m_nRadChopWarp = m_nRadChopWarp;
	advOptDlg.m_nRadChopLight = m_nRadChopLight;
	advOptDlg.m_nRadChopCurve = m_nRadChopCurve;
	advOptDlg.m_nRadAmbientAbs = m_nRadAmbientAbs;
	advOptDlg.m_nRadMaxlightAbs = m_nRadMaxlightAbs;
	advOptDlg.m_fRadRadmin = m_fRadRadmin;
	advOptDlg.m_bRadNoColor = m_bRadNoColor;
	advOptDlg.m_bRadNoColorU = m_bRadNoColorU;
	advOptDlg.m_bRadNoMinlimit = m_bRadNoMinlimit;
	advOptDlg.m_bRadNoBModLight = m_bRadNoBModLight;
	advOptDlg.m_bRadNoStopBleed = m_bRadNoStopBleed;
	advOptDlg.m_bRadNoCurve = m_bRadNoCurve;
	advOptDlg.m_bRadNoSplotchFix = m_bRadNoSplotchFix;
	advOptDlg.m_bRadOnlyBounce = m_bRadOnlyBounce;

	INT_PTR nResponse = advOptDlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK

		// retrieve child dialog variables here
		m_nCompileThreads = advOptDlg.m_nCompileThreads;
		m_bVerbose = advOptDlg.m_bVerbose;
		m_bVerboseLogged = advOptDlg.m_bVerboseLogged;
		m_nSurfaceChop = advOptDlg.m_nSurfaceChop;
		m_bOldBounds = advOptDlg.m_bOldBounds;
		m_bVerboseEnts = advOptDlg.m_bVerboseEnts;
		m_bVerboseBrushes = advOptDlg.m_bVerboseBrushes;
		m_bNoWeld = advOptDlg.m_bNoWeld;
		m_bNoCSG = advOptDlg.m_bNoCSG;
		m_bNoShare = advOptDlg.m_bNoShare;
		m_bNotJunc = advOptDlg.m_bNotJunc;
		m_bNoWater = advOptDlg.m_bNoWater;
		m_bNoOpt = advOptDlg.m_bNoOpt;
		m_bNoPrune = advOptDlg.m_bNoPrune;
		m_bNoMerge = advOptDlg.m_bNoMerge;
		m_bNoSubdiv = advOptDlg.m_bNoSubdiv;
		m_bNoDetail = advOptDlg.m_bNoDetail;
		m_bFullDetail = advOptDlg.m_bFullDetail;
		m_bNoHints = advOptDlg.m_bNoHints;
		m_bQBSP_GLView = advOptDlg.m_bQBSP_GLView;
		m_bVisNoSort = advOptDlg.m_bVisNoSort;
		m_nRadBounces = advOptDlg.m_nRadBounces;
		m_nRadChop = advOptDlg.m_nRadChop;
		m_fRadScale = advOptDlg.m_fRadScale;
		m_fRadSurfScale = advOptDlg.m_fRadSurfScale;
		m_fRadEntScale = advOptDlg.m_fRadEntScale;
		m_fRadAmbient = advOptDlg.m_fRadAmbient;
		m_fRadMaxlight = advOptDlg.m_fRadMaxlight;
		m_bRadExtra = advOptDlg.m_bRadExtra;
		m_bRadNoPVS = advOptDlg.m_bRadNoPVS;
		m_bRadDumpPatches = advOptDlg.m_bRadDumpPatches;
		m_bRadGLView = advOptDlg.m_bRadGLView;
		m_nRadChopSky = advOptDlg.m_nRadChopSky;
		m_nRadChopWarp = advOptDlg.m_nRadChopWarp;
		m_nRadChopLight = advOptDlg.m_nRadChopLight;
		m_nRadChopCurve = advOptDlg.m_nRadChopCurve;
		m_nRadAmbientAbs = advOptDlg.m_nRadAmbientAbs;
		m_nRadMaxlightAbs = advOptDlg.m_nRadMaxlightAbs;
		m_fRadRadmin = advOptDlg.m_fRadRadmin;
		m_bRadNoColor = advOptDlg.m_bRadNoColor;
		m_bRadNoColorU = advOptDlg.m_bRadNoColorU;
		m_bRadNoMinlimit = advOptDlg.m_bRadNoMinlimit;
		m_bRadNoBModLight = advOptDlg.m_bRadNoBModLight;
		m_bRadNoStopBleed = advOptDlg.m_bRadNoStopBleed;
		m_bRadNoCurve = advOptDlg.m_bRadNoCurve;
		m_bRadNoSplotchFix = advOptDlg.m_bRadNoSplotchFix;
		m_bRadOnlyBounce = advOptDlg.m_bRadOnlyBounce;

		UpdateData(false);
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel

		// do nothing, child dialog variable changes discarded
	}
}

