// dk_otterDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "NumericEdit.h"


// Cq2_otterDlg dialog
class Cq2_otterDlg : public CDialog
{
// Construction
public:
	Cq2_otterDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_Q2_OTTER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	CToolTipCtrl m_ToolTip;
	BOOL PreTranslateMessage(MSG *pMsg);

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	TCHAR	m_szCurrentPath[MAX_PATH];
	CString m_strGameDir;
	CString m_strModDir;
	CString m_strMapsDir;
	CString m_strMapFile;
	int m_nCompileType;
	afx_msg void OnBnClickedButtonBrowseMap();
	afx_msg void OnBnClickedButtonConfigureCopyFiles();
	afx_msg void OnBnClickedButtonCompileMap();
	afx_msg void OnEnChangeEditMapFile();
	afx_msg void OnEnChangeEditRadScale();
	afx_msg void OnEnChangeEditRadBounces();
	afx_msg void OnEnChangeEditGameDir();
	afx_msg void OnBnClickedButtonBrowseGameDir();
	afx_msg void OnEnChangeEditMapsDir();
	afx_msg void OnBnClickedButtonBrowseMapsDir();
	afx_msg void OnEnChangeEditModDir();
	afx_msg void OnBnClickedButtonBrowseModDir();
	afx_msg void OnBnClickedRadioCompileType();
	afx_msg void OnEnChangeEditThreads();
	afx_msg void OnDeltaposSpinRadScale(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpinRadBounces(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpinThreads(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpinSurfaceChop(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButtonAdvCompOptions();
	CButton m_ctlButtonConfigureCopyFiles;
	CSpinButtonCtrl m_ctlSpinRadScale;
	CSpinButtonCtrl m_ctlSpinRadBounces;
	CSpinButtonCtrl m_ctlSpinThreads;
	CSpinButtonCtrl m_ctlSpinSurfaceChop;
	CEdit m_ctlEditGameDir;
	CEdit m_ctlEditModDir;
	CEdit m_ctlEditMapsDir;
	CEdit m_ctlEditMapFile;
	CEdit m_ctlEditCompileThreads;
	CEdit m_ctlEditSurfaceChop;
	CNumericEdit m_ctlEditRadScale;
	CEdit m_ctlEditRadBounces;
	int m_nCompileThreads;
	BOOL m_bVerbose;
	BOOL m_bVerboseLogged;
	int m_nSurfaceChop;
	BOOL m_bOldBounds;
	BOOL m_bVerboseEnts;
	BOOL m_bVerboseBrushes;
	BOOL m_bNoWeld;
	BOOL m_bNoCSG;
	BOOL m_bNoShare;
	BOOL m_bNotJunc;
	BOOL m_bNoWater;
	BOOL m_bNoOpt;
	BOOL m_bNoPrune;
	BOOL m_bNoMerge;
	BOOL m_bNoSubdiv;
	BOOL m_bNoDetail;
	BOOL m_bFullDetail;
	BOOL m_bNoHints;
	BOOL m_bQBSP_GLView;
	BOOL m_bVisNoSort;
	int m_nRadBounces;
	int	m_nRadChop;
	float m_fRadScale;
	float m_fRadSurfScale;
	float m_fRadEntScale;
	float m_fRadAmbient;
	float m_fRadMaxlight;
	BOOL m_bRadExtra;
	BOOL m_bRadNoPVS;
	BOOL m_bRadDumpPatches;
	BOOL m_bRadGLView;
	int m_nRadChopSky;
	int m_nRadChopWarp;
	int m_nRadChopLight;
	int m_nRadChopCurve;
	int m_nRadAmbientAbs;
	int m_nRadMaxlightAbs;
	float m_fRadRadmin;
	BOOL m_bRadNoColor;
	BOOL m_bRadNoColorU;
	BOOL m_bRadNoMinlimit;
	BOOL m_bRadNoBModLight;
	BOOL m_bRadNoStopBleed;
	BOOL m_bRadNoCurve;
	BOOL m_bRadNoSplotchFix;
	BOOL m_bRadOnlyBounce;

	// Knightmare added
	BOOL SaveRegistryInfo();
	BOOL LoadRegistryInfo();
	// end Knightmare
};
