// registryinterface.cpp : implementation file
//

#include "stdafx.h"
#include "registryinterface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BOOL CRegistryInterface::WriteRegistryInfoString(const char *pszName, LPCSTR lpszTxt)
{
	LONG	lres;
	DWORD	dwDisp;
	HKEY	hKeyId;

	lres = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\KMQ2 Tools\\Q2Otter", 0, NULL,
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKeyId, &dwDisp);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	lres = RegSetValueEx(hKeyId, pszName, 0, REG_SZ, (unsigned char *)lpszTxt, lstrlen(lpszTxt));

	RegCloseKey(hKeyId);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

BOOL CRegistryInterface::WriteRegistryInfoDword(const char *pszName, DWORD value)
{
	LONG	lres;
	DWORD	dwDisp;
	HKEY	hKeyId;

	lres = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\KMQ2 Tools\\Q2Otter", 0, NULL,
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKeyId, &dwDisp);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	lres = RegSetValueEx(hKeyId, pszName, 0, REG_DWORD, (unsigned char *)&value, sizeof(value));

	RegCloseKey(hKeyId);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

BOOL CRegistryInterface::WriteRegistryInfoBinary(const char *pszName, void *pvBuf, long lSize)
{
	LONG	lres;
	DWORD	dwDisp;
	HKEY	hKeyId;

	lres = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\KMQ2 Tools\\Q2Otter", 0, NULL,
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKeyId, &dwDisp);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	lres = RegSetValueEx(hKeyId, pszName, 0, REG_BINARY, (unsigned char *)pvBuf, lSize);

	RegCloseKey(hKeyId);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

BOOL CRegistryInterface::ReadRegistryInfoString(const char *pszName, char *lpszTxt, long lSize)
{
	HKEY	hKeyId;
	long	lres, lType;
	DWORD	bufSize = lSize;

	lres = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\KMQ2 Tools\\Q2Otter", 0, KEY_READ, &hKeyId);

	if (lres != ERROR_SUCCESS) {
	//	MessageBox("Couldn't open registry key!", "Registry read error", MB_OK | MB_ICONERROR);
		return FALSE;
	}

	lres = RegQueryValueEx(hKeyId, pszName, NULL, (unsigned long *)&lType, (unsigned char *)lpszTxt, &bufSize);

	RegCloseKey(hKeyId);

	if (lres != ERROR_SUCCESS) {
	//	MessageBox("Couldn't query registry value!", "Registry read error", MB_OK | MB_ICONERROR);
		return FALSE;
	}

	CString tmpMsg = lpszTxt;

	return TRUE;
}

BOOL CRegistryInterface::ReadRegistryInfoDword(const char *pszName, void *pvBuf)
{
	HKEY	hKeyId;
	long	lres, lType;
	DWORD	bufSize = sizeof(DWORD);

	lres = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\KMQ2 Tools\\Q2Otter", 0, KEY_READ, &hKeyId);

	if (lres != ERROR_SUCCESS) {
	//	MessageBox("Couldn't open registry key!", "Registry read error", MB_OK | MB_ICONERROR);
		return FALSE;
	}

	lres = RegQueryValueEx(hKeyId, pszName, NULL, (unsigned long *)&lType, (unsigned char *)pvBuf, &bufSize);

	RegCloseKey(hKeyId);

	if (lres != ERROR_SUCCESS) {
	//	MessageBox("Couldn't query registry value!", "Registry read error", MB_OK | MB_ICONERROR);
		return FALSE;
	}

	return TRUE;
}

BOOL CRegistryInterface::ReadRegistryInfoBinary(const char *pszName, void *pvBuf, long *plSize)
{
	HKEY	hKeyId;
	long	lres, lType, lSize;

	if (plSize == NULL)
		plSize = &lSize;

	lres = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\KMQ2 Tools\\Q2Otter", 0, KEY_READ, &hKeyId);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	lres = RegQueryValueEx(hKeyId, pszName, NULL, (unsigned long *)&lType, (unsigned char *)pvBuf, (unsigned long *)plSize);

	RegCloseKey(hKeyId);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}
